bl_info = {
	"name": "Animbox",
	"author": "valangdance",
	"version": (0, 2, 0),
	"blender": (3, 1, 0),
	"location": "3D View > Animbox",
	"description": "Animation, Motion, Sculpting Tools",
	"tracker_url": "",	
	"category": "3D View"}



import bpy


from. import panel_ax
from. import origin_ax
from. import select_by_name_type_ax
from. import misc_ax
from. import visibility_ax

from. anim_presets import animated_curve_bevel_ax, circle_explode_ax, star_burst_ax, trim_paths_ax , spin_rig_ax
from. bone_tools import bendy_bones_ax, bone_circular_array_ax, bone_selection_ax, mesh2bone_ax, offset_bone_keyframes_ax
from.color_box import color_diffuse_ax, color_emission_ax, color_random_ax, offset_color_ax, material_ax
from.c_array import circular_array_ax

# Claybox -----------------------------------------------------------------------------------------------------------

from.claybox import capsule_cx, cylinder_cx, eye_eylid_cx, hemisphere_cone_cx, misc_sculpt_cx
from.claybox import oblate_prolate_spheroid, prism_cx, props_cx, round_cube_cx, sphere_cx

#--------------------------------------------------------------------------------------------------------------------


from. lights_box import lights_ax
from. copy_active_to_selected import copy_act_to_sel_ax
from. deform import lattice_ax, shape_keys_ax, smooth_ctrl_ax

from. obj2curve import obj2curve_anim_ax
from. offset_animation import offset_animation_ax, offset_loc_rot_scale_ax
from. offset_transform import  offset_transform_ax

from. overshoot_motion import overshoot_loc_ax, overshoot_rot_ax, overshoot_scale_ax
from. drivers import drivers_loc_scale_ax, drivers_rotation_ax
from. f_curve_mod import f_curve_cycle_modifier_ax, f_curve_noise_modifier_ax, infinity_cycle_ax

modules = (
           panel_ax, origin_ax, select_by_name_type_ax, misc_ax, visibility_ax,
           # Color
           color_diffuse_ax, color_emission_ax, color_random_ax, offset_color_ax, material_ax,
           # Circular Array
           circular_array_ax,  

           # Claybox:
           capsule_cx, cylinder_cx, eye_eylid_cx, hemisphere_cone_cx, misc_sculpt_cx,
           oblate_prolate_spheroid, prism_cx, props_cx, round_cube_cx, sphere_cx,
            



           # Lights
           lights_ax,
           # Animation Presets
           animated_curve_bevel_ax, circle_explode_ax, star_burst_ax, trim_paths_ax, spin_rig_ax,
           # Bone Tools
           bendy_bones_ax, bone_circular_array_ax, bone_selection_ax, mesh2bone_ax, offset_bone_keyframes_ax,
           # Copy Active to Selected
           copy_act_to_sel_ax,
           # Deform
           lattice_ax, shape_keys_ax, smooth_ctrl_ax,
           # Object to Animated Curve
           obj2curve_anim_ax,
           # Offset Animation
           offset_animation_ax, offset_loc_rot_scale_ax,
           # Offset Static Transformation
           offset_transform_ax,
           # Overshoot Motion
           overshoot_loc_ax, overshoot_rot_ax, overshoot_scale_ax,
           # Drivers
           drivers_loc_scale_ax, drivers_rotation_ax,
           # F-Curve Modifiers
           f_curve_cycle_modifier_ax, f_curve_noise_modifier_ax, infinity_cycle_ax,

           )





def register():
    for c in modules:
        c.register()


def unregister():
    for c in modules:
        c.unregister()


if __name__ == "__main__":
    register()

