import bpy



#================================================================
#                 Star Burst
#================================================================



class OBJECT_OT_star_burst_anbx(bpy.types.Operator):
    '''If nothing is selected:
    'Star Burst' will be placed at the 3D Cursor position.
If selected: 
    at the location of the Selected Object'''

    bl_idname = "object.star_burst_anbx"
    bl_label = "Star Burst"
    bl_options = {'REGISTER', 'UNDO'}


    @classmethod
    def poll(cls, context):
        return (context.mode == 'OBJECT')



    def execute(self, context):

 
        sel_ob = bpy.context.selected_objects
        act_ob = bpy.context.active_object
        cur_frame = bpy.context.scene.frame_current


        cursor = bpy.context.scene.cursor
        cursor_location = bpy.context.scene.cursor.location
        cursor_previous_location = cursor.location.copy()
        
        

        def burst_star_main():

            def create_burst_star():

                current_mode = bpy.context.mode
                if current_mode != 'OBJECT':
                    bpy.ops.object.mode_set(mode='OBJECT')


                bpy.ops.object.select_all(action='DESELECT')


                # Create 1 Line
                ##################################

                # create the Curve Datablock
                curveData = bpy.data.curves.new('1_line', type='CURVE')
                curveData.dimensions = '3D'
                curveData.resolution_u = 12

                # map coords to spline
                polyline = curveData.splines.new('POLY')
                polyline.points.add(1)


                # Points
                polyline.points[0].co =  ((0.5000, -0.0000, 0.8660, 0.0000))
                polyline.points[1].co =  ((1.5000, -0.0000, 2.5981, 0.0000))


                # create Object
                curveOB = bpy.data.objects.new('1_line', curveData)

                # attach to scene and validate context
                
                act_col = bpy.context.view_layer.active_layer_collection
                scn = act_col

                scn.collection.objects.link(curveOB)
                bpy.context.view_layer.objects.active = curveOB
                curveOB.select_set(1)


                for obj in bpy.context.selected_objects:
                    if obj.type == 'CURVE':
                        for s in obj.data.splines:
                            s.use_cyclic_u = True


                # Create 2 Line
                ##################################

                # create the Curve Datablock
                curveData = bpy.data.curves.new('2_line', type='CURVE')
                curveData.dimensions = '3D'
                curveData.resolution_u = 12

                # map coords to spline
                polyline = curveData.splines.new('POLY')
                polyline.points.add(1)


                # Points
                polyline.points[0].co =  ((0.8660, -0.0000, 0.5000, 0.0000))
                polyline.points[1].co =  ((2.5981, -0.0000, 1.5000, 0.0000))


                # create Object
                curveOB = bpy.data.objects.new('2_line', curveData)

                # attach to scene and validate context
                
                act_col = bpy.context.view_layer.active_layer_collection
                scn = act_col

                scn.collection.objects.link(curveOB)
                bpy.context.view_layer.objects.active = curveOB
                curveOB.select_set(1)


                for obj in bpy.context.selected_objects:
                    if obj.type == 'CURVE':
                        for s in obj.data.splines:
                            s.use_cyclic_u = True

                # Create 3 Line
                ##################################

                # create the Curve Datablock
                curveData = bpy.data.curves.new('3_line', type='CURVE')
                curveData.dimensions = '3D'
                curveData.resolution_u = 12

                # map coords to spline
                polyline = curveData.splines.new('POLY')
                polyline.points.add(1)


                # Points
                polyline.points[0].co =  ((1.0000, -0.0000, 0.0000, 0.0000))
                polyline.points[1].co =  ((3.0000, 0.0000, 0.0000, 0.0000))


                # create Object
                curveOB = bpy.data.objects.new('3_line', curveData)

                # attach to scene and validate context
                
                act_col = bpy.context.view_layer.active_layer_collection
                scn = act_col

                scn.collection.objects.link(curveOB)
                bpy.context.view_layer.objects.active = curveOB
                curveOB.select_set(1)


                for obj in bpy.context.selected_objects:
                    if obj.type == 'CURVE':
                        for s in obj.data.splines:
                            s.use_cyclic_u = True


                # Create 4 Line
                ##################################

                # create the Curve Datablock
                curveData = bpy.data.curves.new('4_line', type='CURVE')
                curveData.dimensions = '3D'
                curveData.resolution_u = 12

                # map coords to spline
                polyline = curveData.splines.new('POLY')
                polyline.points.add(1)


                # Points
                polyline.points[0].co =  ((0.8660, 0.0000, -0.5000, 0.0000))
                polyline.points[1].co =  ((2.5981, 0.0000, -1.5000, 0.0000))


                # create Object
                curveOB = bpy.data.objects.new('4_line', curveData)

                # attach to scene and validate context
                
                act_col = bpy.context.view_layer.active_layer_collection
                scn = act_col

                scn.collection.objects.link(curveOB)
                bpy.context.view_layer.objects.active = curveOB
                curveOB.select_set(1)


                for obj in bpy.context.selected_objects:
                    if obj.type == 'CURVE':
                        for s in obj.data.splines:
                            s.use_cyclic_u = True


                # Create 5 Line
                ##################################

                # create the Curve Datablock
                curveData = bpy.data.curves.new('5_line', type='CURVE')
                curveData.dimensions = '3D'
                curveData.resolution_u = 12

                # map coords to spline
                polyline = curveData.splines.new('POLY')
                polyline.points.add(1)


                # Points
                polyline.points[0].co =  ((0.5000, 0.0000, -0.8660, 0.0000))
                polyline.points[1].co =  ((1.5000, 0.0000, -2.5981, 0.0000))


                # create Object
                curveOB = bpy.data.objects.new('5_line', curveData)

                # attach to scene and validate context
                
                act_col = bpy.context.view_layer.active_layer_collection
                scn = act_col

                scn.collection.objects.link(curveOB)
                bpy.context.view_layer.objects.active = curveOB
                curveOB.select_set(1)


                for obj in bpy.context.selected_objects:
                    if obj.type == 'CURVE':
                        for s in obj.data.splines:
                            s.use_cyclic_u = True


                # Create 6 Line
                ##################################

                # create the Curve Datablock
                curveData = bpy.data.curves.new('6_line', type='CURVE')
                curveData.dimensions = '3D'
                curveData.resolution_u = 12

                # map coords to spline
                polyline = curveData.splines.new('POLY')
                polyline.points.add(1)


                # Points
                polyline.points[0].co =  ((0.0000, 0.0000, -1.0000, 0.0000))
                polyline.points[1].co =  ((0.0000, 0.0000, -3.0000, 0.0000))


                # create Object
                curveOB = bpy.data.objects.new('6_line', curveData)

                # attach to scene and validate context
                
                act_col = bpy.context.view_layer.active_layer_collection
                scn = act_col

                scn.collection.objects.link(curveOB)
                bpy.context.view_layer.objects.active = curveOB
                curveOB.select_set(1)


                for obj in bpy.context.selected_objects:
                    if obj.type == 'CURVE':
                        for s in obj.data.splines:
                            s.use_cyclic_u = True



                # Create 7 Line
                ##################################

                # create the Curve Datablock
                curveData = bpy.data.curves.new('7_line', type='CURVE')
                curveData.dimensions = '3D'
                curveData.resolution_u = 12

                # map coords to spline
                polyline = curveData.splines.new('POLY')
                polyline.points.add(1)



                # Points
                polyline.points[0].co =  ((-0.5000, 0.0000, -0.8660, 0.0000))
                polyline.points[1].co =  ((-1.5000, 0.0000, -2.5981, 0.0000))


                # create Object
                curveOB = bpy.data.objects.new('7_line', curveData)

                # attach to scene and validate context
                
                act_col = bpy.context.view_layer.active_layer_collection
                scn = act_col

                scn.collection.objects.link(curveOB)
                bpy.context.view_layer.objects.active = curveOB
                curveOB.select_set(1)


                for obj in bpy.context.selected_objects:
                    if obj.type == 'CURVE':
                        for s in obj.data.splines:
                            s.use_cyclic_u = True



                # Create 8 Line
                ##################################

                # create the Curve Datablock
                curveData = bpy.data.curves.new('8_line', type='CURVE')
                curveData.dimensions = '3D'
                curveData.resolution_u = 12

                # map coords to spline
                polyline = curveData.splines.new('POLY')
                polyline.points.add(1)



                # Points
                polyline.points[0].co =  ((-0.8660, 0.0000, -0.5000, 0.0000))
                polyline.points[1].co =  ((-2.5981, 0.0000, -1.5000, 0.0000))



                # create Object
                curveOB = bpy.data.objects.new('8_line', curveData)

                # attach to scene and validate context
                
                act_col = bpy.context.view_layer.active_layer_collection
                scn = act_col

                scn.collection.objects.link(curveOB)
                bpy.context.view_layer.objects.active = curveOB
                curveOB.select_set(1)


                for obj in bpy.context.selected_objects:
                    if obj.type == 'CURVE':
                        for s in obj.data.splines:
                            s.use_cyclic_u = True




                # Create 9 Line
                ##################################

                # create the Curve Datablock
                curveData = bpy.data.curves.new('9_line', type='CURVE')
                curveData.dimensions = '3D'
                curveData.resolution_u = 12

                # map coords to spline
                polyline = curveData.splines.new('POLY')
                polyline.points.add(1)



                # Points
                polyline.points[0].co =  ((-1.0000, -0.0000, -0.0000, 0.0000))
                polyline.points[1].co =  ((-3.0000, 0.0000, -0.0000, 0.0000))



                # create Object
                curveOB = bpy.data.objects.new('9_line', curveData)

                # attach to scene and validate context
                
                act_col = bpy.context.view_layer.active_layer_collection
                scn = act_col

                scn.collection.objects.link(curveOB)
                bpy.context.view_layer.objects.active = curveOB
                curveOB.select_set(1)


                for obj in bpy.context.selected_objects:
                    if obj.type == 'CURVE':
                        for s in obj.data.splines:
                            s.use_cyclic_u = True




                # Create 10 Line
                ##################################

                # create the Curve Datablock
                curveData = bpy.data.curves.new('10_line', type='CURVE')
                curveData.dimensions = '3D'
                curveData.resolution_u = 12

                # map coords to spline
                polyline = curveData.splines.new('POLY')
                polyline.points.add(1)


                # Points
                polyline.points[0].co =  ((-0.8660, -0.0000, 0.5000, 0.0000))
                polyline.points[1].co =  ((-2.5981, -0.0000, 1.5000, 0.0000))


                # create Object
                curveOB = bpy.data.objects.new('10_line', curveData)

                # attach to scene and validate context
                
                act_col = bpy.context.view_layer.active_layer_collection
                scn = act_col

                scn.collection.objects.link(curveOB)
                bpy.context.view_layer.objects.active = curveOB
                curveOB.select_set(1)


                for obj in bpy.context.selected_objects:
                    if obj.type == 'CURVE':
                        for s in obj.data.splines:
                            s.use_cyclic_u = True




                # Create 11 Line
                ##################################

                # create the Curve Datablock
                curveData = bpy.data.curves.new('11_line', type='CURVE')
                curveData.dimensions = '3D'
                curveData.resolution_u = 12

                # map coords to spline
                polyline = curveData.splines.new('POLY')
                polyline.points.add(1)



                # Points
                polyline.points[0].co =  ((-0.5000, -0.0000, 0.8660, 0.0000))
                polyline.points[1].co =  ((-1.5000, -0.0000, 2.5981, 0.0000))



                # create Object
                curveOB = bpy.data.objects.new('11_line', curveData)

                # attach to scene and validate context
                
                act_col = bpy.context.view_layer.active_layer_collection
                scn = act_col

                scn.collection.objects.link(curveOB)
                bpy.context.view_layer.objects.active = curveOB
                curveOB.select_set(1)


                for obj in bpy.context.selected_objects:
                    if obj.type == 'CURVE':
                        for s in obj.data.splines:
                            s.use_cyclic_u = True





                # Create 12 Line
                ##################################

                # create the Curve Datablock
                curveData = bpy.data.curves.new('12_line', type='CURVE')
                curveData.dimensions = '3D'
                curveData.resolution_u = 12

                # map coords to spline
                polyline = curveData.splines.new('POLY')
                polyline.points.add(1)



                # Points
                polyline.points[0].co =  ((0.0000, 0.0000, 1.0000, 0.0000))
                polyline.points[1].co =  ((-0.0000, 0.0000, 3.0000, 0.0000))



                # create Object
                curveOB = bpy.data.objects.new('12_line', curveData)

                # attach to scene and validate context
                
                act_col = bpy.context.view_layer.active_layer_collection
                scn = act_col

                scn.collection.objects.link(curveOB)
                bpy.context.view_layer.objects.active = curveOB
                curveOB.select_set(1)


                for obj in bpy.context.selected_objects:
                    if obj.type == 'CURVE':
                        for s in obj.data.splines:
                            s.use_cyclic_u = True



                ####################### Lines End




                # Join Selected Objects
                ##########################

                bpy.ops.object.join()


                sel_ob = bpy.context.selected_objects


                for obj in bpy.context.selected_objects:
                    if obj.type == 'CURVE':
                        obj.name = 'Burst_Star'
                        obj.data.name = 'Burst_Star'
                        obj.location = cursor.location
                        for s in obj.data.splines:
                            s.use_cyclic_u = 0



            create_burst_star()

            #===============================================
            #===============================================
            #===============================================
            #===============================================




            def add_new_mat_to_active():
                
                ob = bpy.context.active_object
                mat = bpy.data.materials.get("burst_star_mat")
                if mat is None:
                    mat = bpy.data.materials.new(name="burst_star_mat")    
                   

                if ob.data.materials:
                    ob.data.materials[0] = mat
                else:
                    ob.data.materials.append(mat)       
                       
                bpy.context.object.active_material.use_nodes = True
                        
                for n in bpy.data.materials:

                    num = 17
                    # Check Blender Version
                    blender_version = bpy.app.version[0]

                    if blender_version == 2:
                        num_emission_color = 17
                        num_emission_strength = 18
            
                    if blender_version == 3: 
                        num_emission_color = 19
                        num_emission_strength = 20

                    if blender_version == 4: 
                        num_emission_color = 26
                        num_emission_strength = 27
                        

                    if n.name.startswith("burst_star_mat"):
                        n.node_tree.nodes["Principled BSDF"].inputs[num_emission_color].default_value = (0.88, 0.84, 0.57, 1)
                        n.node_tree.nodes["Principled BSDF"].inputs[num_emission_strength].default_value = 5


            add_new_mat_to_active()
            


            act_ob = bpy.context.active_object


            def curve_radius(num_0, num_1):
                if act_ob:
                    if act_ob.type == 'CURVE':

                        for c in act_ob.data.splines:
                            if c.type == 'BEZIER':
                                
                                c.bezier_points[0].radius = num_0
                                c.bezier_points[0].keyframe_insert(data_path="radius", frame=cur_frame)

                                c.bezier_points[1].radius = num_1
                                c.bezier_points[1].keyframe_insert(data_path="radius", frame=cur_frame)

                            if c.type == 'POLY':

                                c.points[0].radius = num_0
                                c.points[0].keyframe_insert(data_path="radius", frame=cur_frame)

                                c.points[1].radius = num_1
                                c.points[1].keyframe_insert(data_path="radius", frame=cur_frame)
              





            # Insert Keyframe --> Scale / Bevel_Depth
            def insert_keys(frame):
                for o in bpy.context.selected_objects:
                    o.keyframe_insert(data_path = 'scale', frame= frame)
                    o.data.keyframe_insert(data_path = 'bevel_factor_start', frame= frame)
                    o.data.keyframe_insert(data_path = 'bevel_factor_end', frame= frame)

            # Curve Scale
            def curve_scale(num):
                for o in bpy.context.selected_objects:
                    o.scale.x = num
                    o.scale.y = num
                    o.scale.z = num




            for c in bpy.data.curves:
                if c.name.startswith('Burst_Star'):
                    curve_name = c.name


            # Curve Bevel_Factor_Start
            def curve_bevel_factor_start(num):
                bpy.data.curves[curve_name].bevel_factor_start = num


            # Curve Bevel_Factor_End
            def curve_bevel_factor_end(num):
                bpy.data.curves[curve_name].bevel_factor_end = num


            # Curve Bevel_Depth
            def curve_bevel_depth(num):
                bpy.data.curves[curve_name].bevel_depth = num





            bpy.context.object.data.bevel_mode = 'ROUND'
            curve_bevel_depth(0.1)


            cur_frame = bpy.context.scene.frame_current

            # First Frame - Current Frame
            curve_scale(0)
            curve_bevel_factor_start(0.0)
            curve_bevel_factor_end(1.0)
            insert_keys(cur_frame)
            curve_radius(1, 1)



            cur_frame += 10

            # Second Frame
            curve_scale(1)
            curve_bevel_factor_start(0.5)
            curve_bevel_factor_end(0.8)
            insert_keys(cur_frame)
            curve_radius(0.3, 0.1)


            cur_frame += 10

            # Tird Frame
            curve_scale(1)
            curve_bevel_factor_start(1.0)
            curve_bevel_factor_end(1.0)
            insert_keys(cur_frame)
            curve_radius(0.0, 0.0) 


            # Deselect
            for o in bpy.context.selected_objects:
                if o.name.startswith('Burst_Star'):
                    o.select_set(0)


        # burst_star_main()



        def place_at_cursor():

        # If some Object(s) - selected -

            for o in sel_ob:
                bpy.context.view_layer.objects.active = o
                cursor.location = o.location

                burst_star_main()


        if sel_ob:
            place_at_cursor()
            

        if not sel_ob:
            burst_star_main()

  
        # Scene Update
        bpy.context.view_layer.update()
 
        
        # Cursor back
        cursor.location = cursor_previous_location
           


        return {'FINISHED'}





#================================================================
#                   End Star Burst
#================================================================






classes = [OBJECT_OT_star_burst_anbx]




def register():
    for cls in classes:
        bpy.utils.register_class(cls)




def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)



if __name__ == "__main__":
    register()


