import bpy

from bpy.props import (IntProperty)






class OBJECT_OT_bendy_bones_anbx(bpy.types.Operator):
    '''Selected: bone or connected bone chain'''

    bl_idname = "object.bendy_bones_anbx"
    bl_label = "Stretchy BBones"
    bl_options = {'REGISTER', 'UNDO'}


    @classmethod
    def poll(cls, context):
        return (context.object is not None and
             context.object.mode == 'EDIT' and
             len(context.selected_bones) != 0)


    def execute(self, context):
        
        # Refs
        bbone_count = context.scene.bbone_count_anbx       
        
        
        
        # ONE BBONE ------------------------------------------------------------
        #-----------------------------------------------------------------------    
        #-----------------------------------------------------------------------         
      
        
        def one_bbone():
            
            

            edit_bn = bpy.context.editable_bones
            sel_bones = bpy.context.selected_bones

            bpy.context.object.data.display_type = 'BBONE'

            act_bn = bpy.context.active_bone
            act_bn_name = act_bn.name
            
            act_bone_list = []
            act_bone_list.append(act_bn)
            

            b_len  = act_bn.length / 4                      
            
 

            # ----------------------------------------------------------------------
            # New Bone: 

            def new_root_bone():
                act_bn = bpy.context.active_bone
                name = act_bn.name

                new_bone = bpy.context.object.data.edit_bones.new('ctrl_' + name)
                new_bone.head = act_bn.head
                new_bone.tail = act_bn.tail  
                new_bone.roll = act_bn.roll
                
                new_bone.use_deform = False
                
                new_bone.length = b_len 

                new_bone.bbone_z = (( b_len / 10) + b_len / 4)
                new_bone.bbone_x = (( b_len / 10) + b_len / 4)
                            
                act_bn.parent = new_bone
                act_bn.bbone_custom_handle_start = new_bone
            
 
            # ----------------------------------------------------------------------


            act_bn.bbone_segments = bbone_count
            act_bn.bbone_handle_type_start = 'TANGENT'
            act_bn.bbone_handle_type_end = 'TANGENT'
            act_bn.bbone_z = ( b_len / 10)
            act_bn.bbone_x = ( b_len / 10)
            
            new_root_bone()
            


            # Last Bone -------------------------------
                        
            cursor = bpy.context.scene.cursor
            cursor_location = bpy.context.scene.cursor.location
            cursor_previous_location = cursor.location.copy()        
            
            
            bpy.context.scene.cursor.location = act_bn.tail            
            

            tip_bone = bpy.context.object.data.edit_bones.new('tip_' + act_bn_name)
            tip_bone.head = act_bn.head
            tip_bone.tail = act_bn.tail  
            tip_bone.roll = act_bn.roll
            tip_bone.matrix = act_bn.matrix
            tip_bone.use_deform = False
            
            tip_bone.length = b_len 
            tip_bone.bbone_z = (( b_len / 10) + b_len / 4)
            tip_bone.bbone_x = (( b_len / 10) + b_len / 4)
            
            
            bpy.ops.armature.select_all(action='DESELECT')
            
            tip_bone.select = True
            tip_bone.select_head = True
            tip_bone.select_tail = True
            
            bpy.ops.view3d.snap_selected_to_cursor(use_offset=False)
            
            act_bn.bbone_custom_handle_end = tip_bone


            # Cursor back
            cursor.location = cursor_previous_location
            
            
            bpy.ops.armature.select_all(action='DESELECT')        
            
            # Select Bones in Sel Bone List:
            
            for b in edit_bn:
                if b.name == act_bn_name:
                    b.select = 1
           
            
            # Pose Mode ----------------------------------------------------
            
            
            bpy.ops.object.posemode_toggle()
            
            ob = bpy.context.object
            sel_pose_bn = bpy.context.selected_pose_bones  
            pose_bn = bpy.context.object.pose.bones    
            act_bone = bpy.context.active_pose_bone 
            
            tip_bone_name = 'tip_' + act_bone.name
            

                
            str_con = pose_bn[act_bone.name].constraints.new(type='STRETCH_TO')  
            str_con.target = ob
            str_con.subtarget = tip_bone_name
            

            
            
        # MULTIPLE BBONE -------------------------------------------------------
        #-----------------------------------------------------------------------    
        #-----------------------------------------------------------------------    
            
        def multiple_bbone():

      
            edit_bn = bpy.context.editable_bones
            sel_bones = bpy.context.selected_bones

            first_bn =  sel_bones[0] 
            last_bn =  sel_bones[-1] 

            sel_bone_list = []
            for b in sel_bones:
                sel_bone_list.append(b)
                sel_bone_list.append(b.name)



            bpy.context.object.data.display_type = 'BBONE'


            edit_bn = bpy.context.editable_bones
            act_bn = bpy.context.active_bone
            act_bn_roll = act_bn.roll
            b_len  = act_bn.length / 4


            # ----------------------------------------------------------------------
            # New Bone: 

            def new_bone():
                name = act_bn.name

                new_bone = bpy.context.object.data.edit_bones.new('ctrl_' + name)
                new_bone.head = act_bn.head
                new_bone.tail = act_bn.tail  
                new_bone.roll = act_bn.roll
                
                new_bone.use_deform = False
                
                
                new_bone.length = b_len 

                new_bone.bbone_z = (( b_len / 10) + b_len / 4)
                new_bone.bbone_x = (( b_len / 10) + b_len / 4)                

            # ----------------------------------------------------------------------


            sel_bn = bpy.context.selected_bones


            for b in sel_bn:
                b.bbone_segments = bbone_count
                b.bbone_handle_type_start = 'TANGENT'
                b.bbone_handle_type_end = 'TANGENT'
                b.bbone_z = ( b_len / 10)
                b.bbone_x = ( b_len / 10)
                
                act_bn = b
                new_bone()

            bpy.ops.armature.select_all(action='SELECT')
                


            ob = bpy.context.object

            bones = ob.data.edit_bones   
                 
                 
            ####################################################


            num = 0

            for b in range (len(sel_bn)):
                s_num = b


            for bn in sel_bn:
                if num < s_num:
                    first_bn = sel_bn[num+1]
       
                    for b in bones:
                        if b.head == first_bn.head:
                            first_bn.bbone_custom_handle_start = b
                            
                    for b in bones:
                        if b.head == first_bn.tail:
                            first_bn.bbone_custom_handle_end = b    

                
                num += 1     
                 
                 
            # Reload Sel Bones: ----------------------------------
            bpy.ops.armature.select_all(action='DESELECT')    
                 
            for b in bones:
                if b in sel_bone_list:
                    b.select = 1         
                    
            #------------------------------------------------------    
                 
            sel_bones = bpy.context.selected_bones
                 
            first_bone = sel_bones[0]
            second_bone = sel_bones[1]
                
            first_bone_ctrl_name = 'ctrl_' + first_bone.name
            second_bone_ctrl_name = 'ctrl_' + second_bone.name
            
            for b in bones:
                if b.name == first_bone_ctrl_name:
                    first_bone.parent =  b
                    first_bone.bbone_custom_handle_start = b
                    
                if b.name == second_bone_ctrl_name:
                    first_bone.bbone_custom_handle_end = b 
                 


            # Last Bone -------------------------------
            
            cursor = bpy.context.scene.cursor
            cursor_location = bpy.context.scene.cursor.location
            cursor_previous_location = cursor.location.copy()        
            
            
            bpy.context.scene.cursor.location = last_bn.tail
                 
            name = last_bn.name
     
                    
            new_last_bone = bpy.context.object.data.edit_bones.new('end_' + name)
            new_last_bone.head = last_bn.head
            new_last_bone.tail = last_bn.tail  
            new_last_bone.roll = last_bn.roll
            new_last_bone.matrix = last_bn.matrix
            
            new_last_bone.use_deform = False
            
            new_last_bone.length = b_len 
            new_last_bone.bbone_z = (( b_len / 10) + b_len / 4)
            new_last_bone.bbone_x = (( b_len / 10) + b_len / 4)
             
            
            bpy.ops.armature.select_all(action='DESELECT')
            
            new_last_bone.select = True
            new_last_bone.select_head = True
            new_last_bone.select_tail = True
            
            bpy.ops.view3d.snap_selected_to_cursor(use_offset=False)
            
            last_bn.bbone_custom_handle_end = new_last_bone


            # Cursor back
            cursor.location = cursor_previous_location
            
            
            bpy.ops.armature.select_all(action='DESELECT')        
            
            # Select Bones in Sel Bone List:
            
            for b in edit_bn:
                if b.name in sel_bone_list:
                    b.select = 1
                
                

            
            # Pose Mode ----------------------------------------------------
            
            
            bpy.ops.object.posemode_toggle()
            
            ob = bpy.context.object
            sel_pose_bn = bpy.context.selected_pose_bones  
            pose_bn = bpy.context.object.pose.bones    
            act_bone = bpy.context.active_pose_bone      
            
            
            last_pose_bn = sel_pose_bn[-1]
            last_pose_bn_ctrl_name = 'end_' + last_pose_bn.name
            
            
            for b in sel_pose_bn:
                
                
                str_con = pose_bn[b.name].constraints.new(type='STRETCH_TO')  
                str_con.target = ob
                

                act_bone = b
                children = act_bone.children
                
                if children:
                    child_name = act_bone.children[0].name
                    s_target_name = 'ctrl_' + child_name
                      
                      
                    str_con.subtarget = s_target_name
                       
                       
            # Last Pose Bone Subtarget: -----------------------------------------
                       
            last_pose_bn.constraints[-1].subtarget = last_pose_bn_ctrl_name      
            
        
        
        #---------------------------------------------------------
        #---------------------------------------------------------        
        #---------------------------------------------------------
        
        sel_bones = bpy.context.selected_bones
        
        edit_bn = bpy.context.editable_bones


        bone_list_solo = []
        bone_list_mult = []

        for b in sel_bones:
            if b.use_connect == False and len(b.children_recursive) == 0:
                bone_list_solo.append(b.name)
                
            if b.use_connect == False and len(b.children_recursive) != 0:
                bone_list_mult.append(b.name) 
                    

            if b.use_connect == True:
                bone_list_mult.append(b.name) 
                
                

                
                    
        def bn_solo():
            for bn in edit_bn:
                if bn.name in bone_list_solo and bn in sel_bones:
                    return True


        def bn_mult():
            for bn in edit_bn:
                if bn.name in bone_list_mult and bn in sel_bones:
                    return True


        def poly_bone_list():
            if bn_solo() and bn_mult():
                return True

        
        if poly_bone_list():
            self.report({'INFO'}, 'Select only single bone or one connected bone chain') 
            
        if not poly_bone_list():
            
            
            # Check if more than one connected bone chaint selected:
            def too_many_bone_chain():
                sel_bones = bpy.context.selected_bones 
                parent_list = []

                for b in sel_bones:
                    if b.parent is None:
                        parent_list.append(b)
                        
                if len(parent_list) > 1:
                    return True
                             
            
            
            
            # Check if NOT all connected bones are selected: -------------------
            def partially_selected_chain():
                sel_bones = bpy.context.selected_bones
                
                for b in sel_bones:
                    chain_len = len(b.children_recursive) + len(b.parent_recursive) + 1
                    if chain_len > len(sel_bones):
                        return True
                     
                                        
            
            # Check if bone has parent: -----------------------------------------
            def has_parent():
                sel_bones = bpy.context.selected_bones
                
                for b in sel_bones:
                    if b.parent:
                        return True      
                    
                              
            # Check if bone is connected:
            def connected_bones():
                
                sel_bones = bpy.context.selected_bones
                
                for b in sel_bones:
                    if b.use_connect == True:
                        return True
                    

            connected_b = connected_bones()
           
            # First Bone of connected bone chain:
            if len(sel_bones) == 1 and not connected_bones() and sel_bones[0].parent is None and len(sel_bones[0].children_recursive) != 0:
                self.report({'INFO'}, 'Select connected bone chain') 
                              
            # Any Bone of connected bone chain:
            if len(sel_bones) == 1 and connected_bones() and has_parent():
                self.report({'INFO'}, 'Select connected bone chain') 
                                  
                                  
            # Any Bone of NOT connected bone chain:
            if len(sel_bones) == 1 and not connected_bones() and has_parent():
                self.report({'INFO'}, 'Select connected bone chain') 
                                  
                                       
                    
                              
            # Solo Bone:   ------------------------------------------------------------------- 

            if len(sel_bones) == 1 and not connected_bones() and sel_bones[0].parent is None and len(sel_bones[0].children_recursive) == 0:
                one_bbone()
                bpy.ops.object.editmode_toggle()

            #---------------------------------------------------------------------------------

            
            
            # Multiple selected bone of NOT entirely selected (connected) bone chain:  
            if len(sel_bones) > 1 and connected_bones() and partially_selected_chain():
                self.report({'INFO'}, 'Select connected bone chain') 

          

            # Multiple selected bone of NOT entirely selected (NOT connected) bone chain:  
            if len(sel_bones) > 1 and not connected_bones() and partially_selected_chain():
                self.report({'INFO'}, 'Select connected bone chain') 


            # Not Legit operation for multiple connected bone chain: ------------------------------
            if len(sel_bones) > 1 and connected_bones() and not partially_selected_chain() and too_many_bone_chain():
                self.report({'INFO'}, 'Select one connected bone chain') 

            
            
                
            def partially_selected_parent_mult_chain():

                for b in sel_bones:
                    for pb in b.parent_recursive:
                        if pb.select == 0:
                            return True
                            
            def partially_selected_child_mult_chain():

                for b in sel_bones:
                    for pb in b.children_recursive:
                        if pb.select == 0:
                            return True                
                
            
            
            psp_ch = partially_selected_parent_mult_chain()
            psc_ch = partially_selected_child_mult_chain()
            psc = partially_selected_chain()


            # Partially selected multiple connected bone chain: -----------------------------------
            if len(sel_bones) > 1 and connected_bones() and psp_ch or psc_ch and too_many_bone_chain():
                self.report({'INFO'}, 'Select one connected bone chain')  
        

            #--------------------------------------------------------------------------------
            # Legit operation for entire connected bone chain: ------------------------------

            if len(sel_bones) > 1 and connected_bones() and not psc and not too_many_bone_chain() and not psp_ch and not psc_ch:
                multiple_bbone() 
                bpy.ops.object.editmode_toggle()

            #--------------------------------------------------------------------------------



        return {'FINISHED'}





#-----------------------------------------------------------------------------------------------

        
        
        
        
        

classes = [ OBJECT_OT_bendy_bones_anbx,

            
          ]
 
 
 
def register():
    for cls in classes:
        bpy.utils.register_class(cls)
        



    #----------------------- BBone Count ------------------------------
    
    bpy.types.Scene.bbone_count_anbx = bpy.props.IntProperty(
        name="",
        default=12,
        description="BBone Count",
        min=1,
        max=32,
    )
    


 
def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)

    del bpy.types.Scene.bbone_count_anbx
 
 
if __name__ == "__main__":
    register() 








