import bpy




#---------------------------Eey Eyelids-----------------------------------
#-------------------------------------------------------------------------
#-------------------------------------------------------------------------

class OBJECT_OT_create_eyelid_mesh_cbox(bpy.types.Operator):
    '''Create Eye with spherical Eyelids at 3D Cursor'''
    bl_idname = "object.create_eyelid_mesh_cbox"
    bl_label = "Create Eye with Eyelids"
    bl_options = {'REGISTER', 'UNDO'}


    def execute(self, context):
  
        mode = bpy.context.mode
        if mode != 'OBJECT':
            bpy.ops.object.mode_set(mode='OBJECT', toggle=False)



        for ex_obj in bpy.data.objects:
            if ex_obj.type == 'MESH' and ex_obj.name.startswith('eye_block_out'):
                ex_obj.name = 'ex_eye_block_out' 
                ex_obj.data.name = 'ex_eye_block_out' 

            if ex_obj.type == 'MESH' and ex_obj.name.startswith('lower_eyelid_block_out'):
                ex_obj.name = 'ex_lower_eyelid_block_out' 
                ex_obj.data.name = 'ex_lower_eyelid_block_out' 

            if ex_obj.type == 'MESH' and ex_obj.name.startswith('upper_eyelid_block_out'):
                ex_obj.name = 'ex_upper_eyelid_block_out' 
                ex_obj.data.name = 'ex_upper_eyelid_block_out' 


  
        sel_ob = bpy.context.selected_objects
        act_ob = bpy.context.active_object  
        ob = bpy.context.object
  
        cursor = bpy.context.scene.cursor
        cursor_location = bpy.context.scene.cursor.location
        cursor_previous_location = cursor.location.copy()
        


        def add_eye_sphere():
            
            bpy.ops.view3d.snap_cursor_to_center()
            
            bpy.ops.mesh.primitive_uv_sphere_add(radius=1, 
                segments=24,
                ring_count=12,
                enter_editmode=True, 
                align='WORLD', 
                location=(0, 0, 0),
                rotation=(1.5708, 0, 0), 
                scale=(1/2, 1/2, 1/2))  
                  
            bpy.ops.object.mode_set(mode='OBJECT')
            
            
            ob = bpy.context.object
            ob.name = 'eye_block_out' 
            ob.data.name = 'eye_block_out'             
        

            dim_val = ob.dimensions[1] / 2

            cursor.location[1] = (dim_val + (0.1 / 2))

            bpy.ops.object.origin_set(type='ORIGIN_CURSOR', center='MEDIAN')            
            
            bpy.ops.object.modifier_add(type='SUBSURF')
            ob.modifiers["Subdivision"].levels = 2


            cursor.location = cursor_previous_location
            
            bpy.ops.view3d.snap_selected_to_cursor(use_offset=False)

            bpy.ops.object.select_all(action='DESELECT')



        def add_upper_lid_sphere():
            
            bpy.ops.view3d.snap_cursor_to_center()
            
            
            bpy.ops.mesh.primitive_uv_sphere_add(radius=1, 
                segments=32,
                ring_count=32,
                enter_editmode=True, 
                align='WORLD', 
                location=(0, 0, 0),
                rotation=(0, 0, 0), 
                scale=(1.1 / 2, 1.1 / 2, 1.1 / 2))  
                
             

            bpy.ops.mesh.select_all(action='DESELECT')
            bpy.ops.object.mode_set(mode='OBJECT')
            

            
            for v in bpy.context.object.data.vertices:
                if v.co[2] < 0:
                    v.select = True
            bpy.ops.object.mode_set(mode='EDIT')
            bpy.ops.mesh.delete(type='VERT')

            bpy.ops.object.mode_set(mode='OBJECT')
            
            ob = bpy.context.object
            ob.name = 'upper_eyelid_block_out' 
            ob.data.name = 'upper_eyelid_block_out'

            dim_val = ob.dimensions[1] / 2

            cursor.location[1] = dim_val

            bpy.ops.object.origin_set(type='ORIGIN_CURSOR', center='MEDIAN')
              
            ob.rotation_euler[0] = -0.244346
            ob.lock_rotation[1] = True
            ob.lock_rotation[2] = True
            
            bpy.ops.object.modifier_add(type='SOLIDIFY')
            ob.modifiers["Solidify"].thickness = 0.1
            bpy.ops.object.modifier_apply(modifier="Solidify")
            

            bpy.ops.object.modifier_add(type='SUBSURF')
            ob.modifiers["Subdivision"].levels = 2
            bpy.ops.object.modifier_apply(modifier="Subdivision")            
            

            cursor.location = cursor_previous_location
            
            bpy.ops.view3d.snap_selected_to_cursor(use_offset=False)



        def add_lower_lid_sphere():
            
            bpy.ops.view3d.snap_cursor_to_center()
            
            
            
            bpy.ops.mesh.primitive_uv_sphere_add(radius=1, 
                segments=32,
                ring_count=32,
                enter_editmode=True, 
                align='WORLD', 
                location=(0, 0, 0),
                rotation=(0, 0, 0), 
                scale=(1.1 / 2, 1.1 / 2, 1.1 / 2))  
                
             

            bpy.ops.mesh.select_all(action='DESELECT')
            bpy.ops.object.mode_set(mode='OBJECT')
            

            
            for v in bpy.context.object.data.vertices:
                if v.co[2] > 0:
                    v.select = True
            bpy.ops.object.mode_set(mode='EDIT')
            bpy.ops.mesh.delete(type='VERT')

            bpy.ops.object.mode_set(mode='OBJECT')
            
            ob = bpy.context.object
            ob.name = 'lower_eyelid_block_out' 
            ob.data.name = 'lower_eyelid_block_out'            
            

            dim_val = ob.dimensions[1] / 2

            cursor.location[1] = dim_val

            bpy.ops.object.origin_set(type='ORIGIN_CURSOR', center='MEDIAN')
              
            ob.rotation_euler[0] = 0.244346
            ob.lock_rotation[1] = True
            ob.lock_rotation[2] = True
            
            bpy.ops.object.modifier_add(type='SOLIDIFY')
            ob.modifiers["Solidify"].thickness = 0.1
            bpy.ops.object.modifier_apply(modifier="Solidify")
            

            bpy.ops.object.modifier_add(type='SUBSURF')
            ob.modifiers["Subdivision"].levels = 2
            bpy.ops.object.modifier_apply(modifier="Subdivision")  

            cursor.location = cursor_previous_location
            
            bpy.ops.view3d.snap_selected_to_cursor(use_offset=False)



#-----------------------------------------------------

        add_eye_sphere()


        add_upper_lid_sphere()
        
        add_lower_lid_sphere()


        for obj in bpy.data.objects:
            if obj.type == 'MESH' and obj.name.startswith('eye_block_out'):
                obj.select_set(1)


            if obj.type == 'MESH' and obj.name.startswith('lower_eyelid_block_out'):
                obj.select_set(1)


            if obj.type == 'MESH' and obj.name.startswith('upper_eyelid_block_out'):
                obj.select_set(1)
 



        return {'FINISHED'}




#-----------------------------------------------------------------------------   
#------------------------Eey Eyelids End--------------------------------------  
#-----------------------------------------------------------------------------  












classes = [ 

            OBJECT_OT_create_eyelid_mesh_cbox,

          ]
 
 
 
def register():
    for cls in classes:
        bpy.utils.register_class(cls)
        

 
def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)
