import bpy
from bpy.props import (FloatProperty, IntProperty)


       
#------------------------------------------------------------------------       
#-------------------- Oblate Spheroid -----------------------------------  
#------------------------------------------------------------------------       
       
      

# Oblate Spheroid
 
class OBJECT_OT_create_oblate_spheroid_cbox(bpy.types.Operator):
    '''Create Oblate Spheroid'''
    bl_idname = "object.create_oblate_spheroid_cbox"
    bl_label = "Oblate Spheroid"
    bl_options = {'REGISTER', 'UNDO'}


    init_mouse_x: IntProperty()
    init_value: FloatProperty()

    def modal(self, context, event):


        kc = bpy.context.window_manager.keyconfigs
        km = kc.active.keymaps['3D View'].keymap_items['view3d.cursor3d']


        # temp. change
        km.type = 'LEFTMOUSE'
        km.shift = 0  


        # Ref
        stay_in_sculpt_mode = context.scene.stay_in_sculpt_mode_cx          
        create_and_center = context.scene.create_and_center_x_axis_cx
        create_and_mirror = context.scene.create_and_mirror_cx


        def main_ospheroid():

        
            mode = bpy.context.mode
            if mode != 'OBJECT':
                bpy.ops.object.mode_set(mode='OBJECT', toggle=False)


            ob = bpy.context.object
      
            cursor = bpy.context.scene.cursor
            cursor_location = bpy.context.scene.cursor.location
          
            c_x = cursor.location[0]
            c_y = cursor.location[1]
            c_z = cursor.location[2]        
            

            # Cube --------------------------------------------------------        
            def add_cube():
                
                bpy.ops.mesh.primitive_cube_add(size=2, 
                                                enter_editmode=False, 
                                                align='WORLD', 
                                                location=(c_x, c_y, c_z), 
                                                scale=(0.5, 0.5, 0.5))
                                    
            #---------------------------------------------------------------
                           
            add_cube()
            
            ob = bpy.context.object
            ob.name = 'oblate_spheroid' 
            ob.data.name = 'oblate_spheroid'         
            
            
            for i in range(3):
                # add and apply sub mod
                ob.modifiers.new('Subdivision', type='SUBSURF')
                ob.modifiers["Subdivision"].levels = 1
                bpy.ops.object.modifier_apply(modifier="Subdivision")


                # add and apply cast mod
                ob.modifiers.new('Cast', type='CAST')
                ob.modifiers["Cast"].factor = 1
                bpy.ops.object.modifier_apply(modifier="Cast")


            for i in range(4):
                # add and apply cast mod
                ob.modifiers.new('Cast', type='CAST')
                ob.modifiers["Cast"].factor = 1
                bpy.ops.object.modifier_apply(modifier="Cast")

        
            # Scale
        
            bpy.ops.object.editmode_toggle()

            bpy.ops.transform.resize(value=(1.2, 1.2, 0.3))
            
            bpy.ops.object.mode_set(mode='OBJECT', toggle=False)
            
            ob = bpy.context.object          
            ob.scale.x /= 10
            ob.scale.y /= 10
            ob.scale.z /= 10

        #------------------------------------------------------------------------

        # Place 3D Cursor
        if event.type == 'LEFTMOUSE' and event.value == 'PRESS':
            return {'PASS_THROUGH'}  


        if event.type == 'LEFTMOUSE' and event.value == 'RELEASE':
            main_ospheroid()
           
                
            return {'RUNNING_MODAL'}
        
 
        sel_ob = bpy.context.selected_objects
        
        if sel_ob:
            obj = sel_ob[0]
            
            if event.type == 'MOUSEMOVE':
                delta = self.init_mouse_x - (event.mouse_x - event.mouse_prev_press_x)
                obj.scale.x = self.init_value + delta * -0.05
                obj.scale.y = self.init_value + delta * -0.05
                obj.scale.z = self.init_value + delta * -0.05


                # change mouse cursor
                bpy.context.window.cursor_modal_set("MOVE_X")

                # header info
                bpy.context.area.header_text_set('Right Click or press  ESC | SHIFT | CTRL | ALT | SPACEBAR | ENTER  -  to Confirm')


        if event.type in {'RIGHTMOUSE', 'SPACE', 'RET', 'LEFT_CTRL', 'LEFT_ALT', 'LEFT_SHIFT', 'ESC'} and event.value == 'PRESS':

            # restore keymaps
            km.type = 'RIGHTMOUSE'
            km.shift = 1           
            

            # restore mouse cursor
            bpy.context.window.cursor_modal_restore()

            # restore info header
            bpy.context.area.header_text_set(None)

            # apply scale
            bpy.ops.object.transform_apply(location=False, rotation=False, scale=True)


            act_ob = bpy.context.active_object
            if stay_in_sculpt_mode:
                if act_ob is not None and act_ob.type == 'MESH':
                    bpy.ops.object.mode_set(mode='SCULPT', toggle=False)
                    

            if create_and_center:
                bpy.ops.object.center_obj_cbox()

            if create_and_mirror:
                bpy.ops.object.mirror_mod_cbox() 


            return {'FINISHED'}

        
        return {'RUNNING_MODAL'}



    def invoke(self, context, event):

        mode = bpy.context.mode
        if mode != 'OBJECT':
            bpy.ops.object.mode_set(mode='OBJECT', toggle=False)


        bpy.ops.object.select_all(action='DESELECT')

        context.window_manager.modal_handler_add(self)

        return {'RUNNING_MODAL'}


#------------------------------------------------------------------------       
#--------------------Oblate Spheroid End---------------------------------     
#------------------------------------------------------------------------       
       


       
#------------------------------------------------------------------------       
#-------------------- Prolate Spheroid -----------------------------------  
#------------------------------------------------------------------------       
       
      

# Prolate Spheroid
 
class OBJECT_OT_create_prolate_spheroid_cbox(bpy.types.Operator):
    '''Create Prolate Spheroid'''
    bl_idname = "object.create_prolate_spheroid_cbox"
    bl_label = "Prolate Spheroid"
    bl_options = {'REGISTER', 'UNDO'}


    init_mouse_x: IntProperty()
    init_value: FloatProperty()

    def modal(self, context, event):

        kc = bpy.context.window_manager.keyconfigs
        km = kc.active.keymaps['3D View'].keymap_items['view3d.cursor3d']


        # temp. change
        km.type = 'LEFTMOUSE'
        km.shift = 0  


        # Ref
        stay_in_sculpt_mode = context.scene.stay_in_sculpt_mode_cx          
        create_and_center = context.scene.create_and_center_x_axis_cx
        create_and_mirror = context.scene.create_and_mirror_cx

        def main_pspheroid():

           
            mode = bpy.context.mode
            if mode != 'OBJECT':
                bpy.ops.object.mode_set(mode='OBJECT', toggle=False)


            ob = bpy.context.object
      
            cursor = bpy.context.scene.cursor
            cursor_location = bpy.context.scene.cursor.location
          
            c_x = cursor.location[0]
            c_y = cursor.location[1]
            c_z = cursor.location[2]        
            

            # Cube --------------------------------------------------------        
            def add_cube():
                
                bpy.ops.mesh.primitive_cube_add(size=2, 
                                                enter_editmode=False, 
                                                align='WORLD', 
                                                location=(c_x, c_y, c_z), 
                                                scale=(0.5, 0.5, 0.5))
                                    
            #---------------------------------------------------------------
                           
            add_cube()
            
            ob = bpy.context.object
            ob.name = 'prolate_spheroid' 
            ob.data.name = 'prolate_spheroid'         
            
            

            for i in range(3):
                # add and apply sub mod
                ob.modifiers.new('Subdivision', type='SUBSURF')
                ob.modifiers["Subdivision"].levels = 1
                bpy.ops.object.modifier_apply(modifier="Subdivision")


                # add and apply cast mod
                ob.modifiers.new('Cast', type='CAST')
                ob.modifiers["Cast"].factor = 1
                bpy.ops.object.modifier_apply(modifier="Cast")


            for i in range(4):
                # add and apply cast mod
                ob.modifiers.new('Cast', type='CAST')
                ob.modifiers["Cast"].factor = 1
                bpy.ops.object.modifier_apply(modifier="Cast")

        
        
            # Scale
        
            bpy.ops.object.editmode_toggle()

            bpy.ops.transform.resize(value=(0.4, 0.4, 1.2))
            
            bpy.ops.object.mode_set(mode='OBJECT', toggle=False)
            
          
            ob = bpy.context.object          
            ob.scale.x /= 10
            ob.scale.y /= 10
            ob.scale.z /= 10

        #------------------------------------------------------------------------

        # Place 3D Cursor
        if event.type == 'LEFTMOUSE' and event.value == 'PRESS':
            return {'PASS_THROUGH'}  


        if event.type == 'LEFTMOUSE' and event.value == 'RELEASE':
            main_pspheroid()
           
                
            return {'RUNNING_MODAL'}
        
 
        sel_ob = bpy.context.selected_objects
        
        if sel_ob:
            obj = sel_ob[0]
            
            if event.type == 'MOUSEMOVE':
                delta = self.init_mouse_x - (event.mouse_x - event.mouse_prev_press_x)
                obj.scale.x = self.init_value + delta * -0.05
                obj.scale.y = self.init_value + delta * -0.05
                obj.scale.z = self.init_value + delta * -0.05


                # change mouse cursor
                bpy.context.window.cursor_modal_set("MOVE_X")

                # header info
                bpy.context.area.header_text_set('Right Click or press  ESC | SHIFT | CTRL | ALT | SPACEBAR | ENTER  -  to Confirm')


        if event.type in {'RIGHTMOUSE', 'SPACE', 'RET', 'LEFT_CTRL', 'LEFT_ALT', 'LEFT_SHIFT', 'ESC'} and event.value == 'PRESS':

            # restore keymaps
            km.type = 'RIGHTMOUSE'
            km.shift = 1           
            

            # restore mouse cursor
            bpy.context.window.cursor_modal_restore()

            # restore info header
            bpy.context.area.header_text_set(None)

            # apply scale
            bpy.ops.object.transform_apply(location=False, rotation=False, scale=True)


            act_ob = bpy.context.active_object
            if stay_in_sculpt_mode:
                if act_ob is not None and act_ob.type == 'MESH':
                    bpy.ops.object.mode_set(mode='SCULPT', toggle=False)
                    

            if create_and_center:
                bpy.ops.object.center_obj_cbox()

            if create_and_mirror:
                bpy.ops.object.mirror_mod_cbox() 


            return {'FINISHED'}

        
        return {'RUNNING_MODAL'}



    def invoke(self, context, event):

        mode = bpy.context.mode
        if mode != 'OBJECT':
            bpy.ops.object.mode_set(mode='OBJECT', toggle=False)


        bpy.ops.object.select_all(action='DESELECT')

        context.window_manager.modal_handler_add(self)

        return {'RUNNING_MODAL'}


#------------------------------------------------------------------------       
#--------------------Prolate Spheroid End---------------------------------     
#------------------------------------------------------------------------       
       
 


       
       
       
classes = [ OBJECT_OT_create_oblate_spheroid_cbox,
            OBJECT_OT_create_prolate_spheroid_cbox,

            
          ]
 
 
 
def register():
    for cls in classes:
        bpy.utils.register_class(cls)
        

 
def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)

 
 
 
if __name__ == "__main__":
    register() 