import bpy 

from bpy.props import (BoolProperty, FloatProperty, IntProperty)




# reset fun -------------------------------------------------------------

def reset_center_on_x_axis_cx(self, context):
    sc = bpy.context.scene
    sc.property_unset('create_and_mirror_cx')


def reset_create_and_mirror_cx(self, context):
    sc = bpy.context.scene
    sc.property_unset('create_and_center_x_axis_cx')




#------------------------------------------------------------------------


def register():

#========================= Stay in Sculpt Mode ==========================

    bpy.types.Scene.stay_in_sculpt_mode_cx = bpy.props.BoolProperty(
        name="",
        description=" Stay in Sculpt Mode ",
        default = False,
    )


#========================================================================
        
#========================= Create and Center on X axis ==================

    bpy.types.Scene.create_and_center_x_axis_cx = bpy.props.BoolProperty(
        name="",
        description=" Create and Center on X axis ",
        default = False,
        update = reset_center_on_x_axis_cx,

    )


#========================================================================
    
#========================= Create and Mirror ============================

    bpy.types.Scene.create_and_mirror_cx = bpy.props.BoolProperty(
        name="",
        description=" Create and Mirror ",
        default = False,
        update = reset_create_and_mirror_cx,

    )


#========================================================================
    



   
#========================= Color picker =================================

    bpy.types.Scene.fill_object_color_cx = bpy.props.FloatVectorProperty(
            name="",
            subtype='COLOR',
            default=(1.0, 1.0, 1.0, 1.0),
            size=4,
            min=0.0, max=1.0,
            description="Select Vertext Color",

            )

        
#========================================================================

        

def unregister():

    del bpy.types.Scene.stay_in_sculpt_mode_cx   
    del bpy.types.Scene.create_and_center_x_axis_cx   
    del bpy.types.Scene.create_and_mirror_cx
    del bpy.types.Scene.fill_object_color_cx    
        
        
        
        
if __name__ == "__main__":
    register()

        
        
        
        