import bpy
from bpy.props import (FloatVectorProperty)





# Diffuse Color function
#====================================

def change_diffuse_color_fun_anbx(self, context):
    mat_object_types = ['CURVE', 'MESH', 'FONT', 'SURFACE', 'META']
    sel_ob = bpy.context.selected_objects
    act_ob = bpy.context.active_object
    cur_frame = bpy.context.scene.frame_current

    # location -> material_ax.py
    add_keyframe = context.scene.mat_light_add_keyframe_anbx
 

    #======================================
    # Surfaces

    node_list = ["Principled BSDF",
                 "Diffuse BSDF", "Emission",
                 "Glass BSDF", "Anisotropic BSDF",
                 "Glossy BSDF", "Principled Hair BSDF",
                 "Principled Volume", "Refraction BSDF",
                 "Specular", "Subsurface Scattering",
                 "Toon BSDF", "Translucent BSDF",
                 "Transparent BSDF", "Velvet BSDF",
                 ]



    for o in sel_ob:
        if o.type in mat_object_types:
            if o == act_ob:
                o_name = o.name
                for m in o.data.materials:
                    for n in m.node_tree.nodes:
                        if n.name in node_list:
                            node_name = n.name
                            inputs = n.inputs
                            color = inputs[0].default_value



    for o in sel_ob:
        mat_object_types = ['CURVE', 'MESH', 'FONT', 'SURFACE', 'META']
        bpy.context.view_layer.objects.active = o

        if o.type in mat_object_types:

            for m in o.data.materials:
                mat_name = m.name
                m.diffuse_color = self.diffuse_color_changer_anbx

                # if bool 'add keyframe'
                if add_keyframe:
                    m.diffuse_color.data.keyframe_insert(data_path="diffuse_color", frame=cur_frame)


                for n in bpy.data.materials[mat_name].node_tree.nodes:
                    if n.name in node_list:
                        n.inputs[0].default_value  = self.diffuse_color_changer_anbx
                        
                        # if bool 'add keyframe'
                        if add_keyframe:
                            n.inputs[0].keyframe_insert(data_path="default_value", frame=cur_frame)





#=====================================




def register():

    bpy.types.Scene.diffuse_color_changer_anbx = bpy.props.FloatVectorProperty(
            name="Diffuse",
            subtype='COLOR',
            default=(1.0, 1.0, 1.0, 1.0),
            size=4,
            min=0.0, max=1.0,
            description="Selected Objects",
            update = change_diffuse_color_fun_anbx
            )



def unregister():

    del bpy.types.Scene.diffuse_color_changer_anbx



if __name__ == "__main__":
    register()








