import bpy
import math
from bpy.props import (BoolProperty, FloatProperty, IntProperty)




#============================ Driver Location ======================



class OBJECT_OT_driver_location_anbx(bpy.types.Operator):
    '''Add Location Driver to Selected'''

    bl_idname = "object.driver_location_anbx"
    bl_label = "Location"
    bl_options = {'REGISTER', 'UNDO'}

    @classmethod
    def poll(cls, context):
        return (context.object is not None and
                context.object.mode == 'OBJECT' and
                len(context.selected_objects) != 0)


    def execute(self, context):
  
        # Ref 
        sin_bool = context.scene.driver_sine_wave_anbx  
        offset_motion_bool = context.scene.driver_offset_motion_anbx        
        offset_motion_amp = context.scene.driver_offset_motion_amplitude_anbx      
         
        speed = context.scene.driver_speed_anbx
          
        x_axis = context.scene.driver_axis_x_anbx
        y_axis = context.scene.driver_axis_y_anbx
        z_axis = context.scene.driver_axis_z_anbx
        
        offset_speed = context.scene.driver_offset_speed_anbx
        
        sel_ob = bpy.context.selected_objects
        ob = bpy.context.object
        
    
        def loc_driver_offseted(transf, index):
            
            offset = 0
            for o in sel_ob:
                n_dr = o.driver_add(transf, index)
                n_dr.driver.type = 'SCRIPTED'
            
                amp = offset_motion_amp
                freq = speed / speed
                       
                if sin_bool:    
                    if x_axis:
                        if ob.location.x > 0:
                            loc = ob.location.x                         
                            n_dr.driver.expression = "{}  * sin({} + (frame * {}) /{}) + {}".format(amp, offset, speed, freq, loc) 
                    
                        if ob.location.x < 0:
                            loc = ob.location.x * (-1)        
                            n_dr.driver.expression = "{}  * sin({} + (frame * {}) /{}) - {}".format(amp, offset, speed, freq, loc) 
      
      
                        if ob.location.x == 0:                        
                            n_dr.driver.expression = "{}  * sin({} + (frame * {}) /{})".format(amp, offset, speed, freq) 
                    
 

      
      
                    if y_axis:            
                        if ob.location.y > 0:
                            loc = ob.location.y                         
                            n_dr.driver.expression = "{}  * sin({} + (frame * {}) /{}) + {}".format(amp, offset, speed, freq, loc) 
                    
                        if ob.location.y < 0:
                            loc = ob.location.y * (-1)        
                            n_dr.driver.expression = "{}  * sin({} + (frame * {}) /{}) - {}".format(amp, offset, speed, freq, loc) 
      
                        if ob.location.y == 0:                        
                            n_dr.driver.expression = "{}  * sin({} + (frame * {}) /{})".format(amp, offset, speed, freq) 
                          
      
      
      
                    if z_axis:
                        if ob.location.z > 0:
                            loc = ob.location.z                        
                            n_dr.driver.expression = "{}  * sin({} + (frame * {}) /{}) + {}".format(amp, offset, speed, freq, loc) 
                    
                        if ob.location.z < 0:
                            loc = ob.location.z * (-1)        
                            n_dr.driver.expression = "{}  * sin({} + (frame * {}) /{}) - {}".format(amp, offset, speed, freq, loc) 
      
      
                        if ob.location.z == 0:                        
                            n_dr.driver.expression = "{}  * sin({} + (frame * {}) /{})".format(amp, offset, speed, freq) 
                          
      
                       
                else:  
                    
                    if x_axis:
                        if ob.location.x > 0:
                            loc = ob.location.x                       
                            n_dr.driver.expression = "{}  * ({} + (frame * {}) /{}) + {}".format(amp, offset, speed, freq, loc) 
                                
                
                        if ob.location.x < 0:
                            loc = ob.location.x * (-1)                 
                            n_dr.driver.expression = "{}  * ({} + (frame * {}) /{}) - {}".format(amp, offset, speed, freq, loc) 


                        if ob.location.x == 0:                        
                            n_dr.driver.expression = "{}  * ({} + (frame * {}) /{})".format(amp, offset, speed, freq)
                                   
               
               
                    if y_axis:
                        if ob.location.y > 0:
                            loc = ob.location.y                      
                            n_dr.driver.expression = "{}  * ({} + (frame * {}) /{}) + {}".format(amp, offset, speed, freq, loc) 
                                
                
                        if ob.location.y < 0:
                            loc = ob.location.y * (-1)                 
                            n_dr.driver.expression = "{}  * ({} + (frame * {}) /{}) - {}".format(amp, offset, speed, freq, loc) 
               
               
                        if ob.location.y == 0:                        
                            n_dr.driver.expression = "{}  * ({} + (frame * {}) /{})".format(amp, offset, speed, freq)
                                   
               
               
                    if z_axis:
                        if ob.location.z > 0:
                            loc = ob.location.z                     
                            n_dr.driver.expression = "{}  * ({} + (frame * {}) /{}) + {}".format(amp, offset, speed, freq, loc) 
                                
                
                        if ob.location.z < 0:
                            loc = ob.location.z * (-1)                 
                            n_dr.driver.expression = "{}  * ({} + (frame * {}) /{}) - {}".format(amp, offset, speed, freq, loc) 
               
               
                        if ob.location.z == 0:                        
                            n_dr.driver.expression = "{}  * ({} + (frame * {}) /{})".format(amp, offset, speed, freq)
                                   
                                                 
               
                
                offset += (1 + offset_speed)
     
 
 
        def loc_driver(transf, index):
            n_dr = o.driver_add(transf, index)
            n_dr.driver.type = 'SCRIPTED'
            
            amp = offset_motion_amp
            freq = speed / speed

 
            if sin_bool:
                
                if x_axis:
                    if ob.location.x > 0:
                        loc = ob.location.x
                        n_dr.driver.expression = "({} * sin(frame * {}) /{}) + {}".format(amp, speed, freq, loc)
            
                    if ob.location.x < 0:
                        loc = ob.location.x * (-1) 
                        n_dr.driver.expression = "({} * sin(frame * {}) /{}) - {}".format(amp, speed, freq, loc)
            
            
                    if ob.location.x == 0:
                        n_dr.driver.expression = "({} * sin(frame * {}) /{})".format(amp, speed, freq)
                        
 
 
                if y_axis:
                    if ob.location.y > 0:
                        loc = ob.location.y
                        n_dr.driver.expression = "({} * sin(frame * {}) /{}) + {}".format(amp, speed, freq, loc)
            
                    if ob.location.y < 0:
                        loc = ob.location.y * (-1) 
                        n_dr.driver.expression = "({} * sin(frame * {}) /{}) - {}".format(amp, speed, freq, loc)
             
             
                    if ob.location.y == 0:
                        n_dr.driver.expression = "({} * sin(frame * {}) /{})".format(amp, speed, freq)
                         
 
 
                if z_axis:
                    if ob.location.z > 0:
                        loc = ob.location.z
                        n_dr.driver.expression = "({} * sin(frame * {}) /{}) + {}".format(amp, speed, freq, loc)
            
                    if ob.location.z < 0:
                        loc = ob.location.z * (-1) 
                        n_dr.driver.expression = "({} * sin(frame * {}) /{}) - {}".format(amp, speed, freq, loc)
             
             
                    if ob.location.z == 0:
                        n_dr.driver.expression = "({} * sin(frame * {}) /{})".format(amp, speed, freq)
                          
            
            
            else:
                     
                if x_axis:
                    if ob.location.x > 0:
                        loc = ob.location.x                                           
                        n_dr.driver.expression = "({} * (frame * {}) /{}) + {}".format(amp, speed, freq, loc)
            
     
                    if ob.location.x < 0:
                        loc = ob.location.x * (-1)  
                        n_dr.driver.expression = "({} * (frame * {}) /{}) - {}".format(amp, speed, freq, loc)
 

                    if ob.location.x == 0:
                        n_dr.driver.expression = "({} * (frame * {}) /{})".format(amp, speed, freq)
                        



                if y_axis:
                    if ob.location.y > 0:
                        loc = ob.location.y                                           
                        n_dr.driver.expression = "({} * (frame * {}) /{}) + {}".format(amp, speed, freq, loc)
            
     
                    if ob.location.y < 0:
                        loc = ob.location.y * (-1)  
                        n_dr.driver.expression = "({} * (frame * {}) /{}) - {}".format(amp, speed, freq, loc)
 

                    if ob.location.y == 0:
                        n_dr.driver.expression = "({} * (frame * {}) /{})".format(amp, speed, freq)
                        



                if z_axis:
                    if ob.location.z > 0:
                        loc = ob.location.z                                          
                        n_dr.driver.expression = "({} * (frame * {}) /{}) + {}".format(amp, speed, freq, loc)
            
     
                    if ob.location.z < 0:
                        loc = ob.location.z * (-1)  
                        n_dr.driver.expression = "({} * (frame * {}) /{}) - {}".format(amp, speed, freq, loc)
 

                    if ob.location.z == 0:
                        n_dr.driver.expression = "({} * (frame * {}) /{})".format(amp, speed, freq)
                        







        def add_driver_offseted():
                   
            if x_axis:
                loc_driver_offseted('location', 0)       
            if y_axis:
                loc_driver_offseted('location', 1)       
            if z_axis:
                loc_driver_offseted('location', 2)       
            
            else:
                pass                  
  
                
 

        def add_driver_main():
                   
            if x_axis:
                loc_driver('location', 0)       
            if y_axis:
                loc_driver('location', 1)       
            if z_axis:
                loc_driver('location', 2)       
            
            else:
                pass                  

 
        for o in bpy.context.selected_objects:
            if offset_motion_bool:
                add_driver_offseted()
             
            if not offset_motion_bool:   
                speed += offset_speed
                add_driver_main()
      
 

        return {'FINISHED'}

#============================ End Location ======================








#============================ Driver Scale ======================



class OBJECT_OT_driver_scale_anbx(bpy.types.Operator):
    '''Add Scale Driver to Selected'''

    bl_idname = "object.driver_scale_anbx"
    bl_label = "Scale"
    bl_options = {'REGISTER', 'UNDO'}

    @classmethod
    def poll(cls, context):
        return (context.object is not None and
                context.object.mode == 'OBJECT' and
                len(context.selected_objects) != 0)


    def execute(self, context):
  
        # Ref 
        sin_bool = context.scene.driver_sine_wave_anbx  
        offset_motion_bool = context.scene.driver_offset_motion_anbx        
        offset_motion_amp = context.scene.driver_offset_motion_amplitude_anbx      
          
        
        speed = context.scene.driver_speed_anbx
          
        x_axis = context.scene.driver_axis_x_anbx
        y_axis = context.scene.driver_axis_y_anbx
        z_axis = context.scene.driver_axis_z_anbx
        
        offset_speed = context.scene.driver_offset_speed_anbx
        
        sel_ob = bpy.context.selected_objects
        
        
    
        def scale_driver_offseted(transf, index):
            
            offset = 0
            for o in sel_ob:
                n_dr = o.driver_add(transf, index)
                n_dr.driver.type = 'SCRIPTED'
            
                amp = offset_motion_amp
                freq = speed / speed
                       
                if sin_bool:  
                    
                    if x_axis:
                        dim = o.dimensions.x / 2                         
                        n_dr.driver.expression = "{}  * sin({} + (frame * {}) /{}) + {}".format(amp, offset, speed, freq, dim) 
                
                                           
                    if y_axis:
                        dim = o.dimensions.y / 2                         
                        n_dr.driver.expression = "{}  * sin({} + (frame * {}) /{}) + {}".format(amp, offset, speed, freq, dim) 
                
                                                                    
                    if z_axis:
                        dim = o.dimensions.z / 2                         
                        n_dr.driver.expression = "{}  * sin({} + (frame * {}) /{}) + {}".format(amp, offset, speed, freq, dim) 
                                     
   
       
                    else:
                        if not x_axis and not y_axis and not z_axis:                           
                            n_dr.driver.expression = "{}  * sin({} + (frame * {}) /{}) + 1".format(amp, offset, speed, freq) 
  
    
                       
                else:                         
                    n_dr.driver.expression = "{}  * ({} + (frame * {}) /{}) + 1".format(amp, offset, speed, freq) 
                                
                
                offset += (1 + offset_speed)
     
 
 
        def scale_driver(transf, index):
            n_dr = o.driver_add(transf, index)
            n_dr.driver.type = 'SCRIPTED'
            
            amp = offset_motion_amp
            freq = speed / speed

 
            if sin_bool:
            
                if x_axis:
                    dim = o.dimensions.x / 2                     
                    n_dr.driver.expression = "{} * sin(frame * {}) /{} + {}".format(amp, speed, freq, dim)
            
                if y_axis:
                    dim = o.dimensions.y / 2                     
                    n_dr.driver.expression = "{} * sin(frame * {}) /{} + {}".format(amp, speed, freq, dim)
            
                if z_axis:
                    dim = o.dimensions.z / 2                     
                    n_dr.driver.expression = "{} * sin(frame * {}) /{} + {}".format(amp, speed, freq, dim)
            
                                    
   
                else:
                    if not x_axis and not y_axis and not z_axis:  
                        n_dr.driver.expression = "{} * sin(frame * {}) /{} + 1".format(amp, speed, freq)   
                        
                                
            
            else:
                n_dr.driver.expression = "{} * (frame * {}) /{} + 1".format(amp, speed, freq)
            
 
 
 

        def add_driver_offseted():
                   
            if x_axis:
                scale_driver_offseted('scale', 0)       
            if y_axis:
                scale_driver_offseted('scale', 1)       
            if z_axis:
                scale_driver_offseted('scale', 2)       
            
            else:
                if not x_axis and not y_axis and not z_axis:
                    scale_driver_offseted('scale', 0) 
                    scale_driver_offseted('scale', 1) 
                    scale_driver_offseted('scale', 2) 
     

        def add_driver_main():
                   
            if x_axis:
                scale_driver('scale', 0)       
            if y_axis:
                scale_driver('scale', 1)       
            if z_axis:
                scale_driver('scale', 2)       
            
            else:
                if not x_axis and not y_axis and not z_axis:
                    scale_driver('scale', 0) 
                    scale_driver('scale', 1) 
                    scale_driver('scale', 2) 
     

 
        for o in bpy.context.selected_objects:
            if offset_motion_bool:
                add_driver_offseted()
             
            if not offset_motion_bool:   
                speed += offset_speed
                add_driver_main()
      
 

        return {'FINISHED'}

#============================ End Scale ======================


 

#============================ Remove Location Driver======================

 
class OBJECT_OT_remove_location_driver_anbx(bpy.types.Operator):
    '''Remove Location Driver'''

    bl_idname = "object.remove_location_driver_anbx"
    bl_label = ""
    bl_options = {'REGISTER', 'UNDO'}

    @classmethod
    def poll(cls, context):
        return (context.object is not None and
                context.object.mode == 'OBJECT' and
                len(context.selected_objects) != 0)


    def execute(self, context):
        
        bpy.context.scene.property_unset('driver_offset_motion_amplitude_anbx')               
        bpy.context.scene.property_unset('driver_offset_speed_anbx')        
        bpy.context.scene.property_unset('driver_speed_anbx')        
        
        
        act_ob_name = bpy.context.active_object.name
  
        def remove_driver(transf, index):
            r_dr = o.driver_remove(transf, index)
 

        def remove_driver_main():
            remove_driver('location', 0)
            remove_driver('location', 1)
            remove_driver('location', 2)


        
        for o in bpy.context.selected_objects:
            bpy.context.view_layer.objects.active = o
            remove_driver_main()
            
        for o in bpy.context.selected_objects:
            if o.name == act_ob_name:
                bpy.context.view_layer.objects.active = o 
                
            
                  
        return {'FINISHED'}


#============================ End Remove Location Driver======================





#============================ Remove Scale Driver======================


 
class OBJECT_OT_remove_scale_driver_anbx(bpy.types.Operator):
    '''Remove Scale Driver'''

    bl_idname = "object.remove_scale_driver_anbx"
    bl_label = ""
    bl_options = {'REGISTER', 'UNDO'}

    @classmethod
    def poll(cls, context):
        return (context.object is not None and
                context.object.mode == 'OBJECT' and
                len(context.selected_objects) != 0)


    def execute(self, context):
        
        bpy.context.scene.property_unset('driver_offset_motion_amplitude_anbx')               
        bpy.context.scene.property_unset('driver_offset_speed_anbx')        
        bpy.context.scene.property_unset('driver_speed_anbx')        
        
        
        act_ob_name = bpy.context.active_object.name
  
        def remove_driver(transf, index):
            r_dr = o.driver_remove(transf, index)
 

        def remove_driver_main():
            remove_driver('scale', 0)
            remove_driver('scale', 1)
            remove_driver('scale', 2)


        
        for o in bpy.context.selected_objects:
            bpy.context.view_layer.objects.active = o
            remove_driver_main()
            
        for o in bpy.context.selected_objects:
            if o.name == act_ob_name:
                bpy.context.view_layer.objects.active = o 
                
            
                  
        return {'FINISHED'}



#============================ End Remove Scale Driver======================









classes = [ OBJECT_OT_driver_location_anbx,
            OBJECT_OT_driver_scale_anbx,
            OBJECT_OT_remove_location_driver_anbx,
            OBJECT_OT_remove_scale_driver_anbx,
 
            
          ]
 
 
 
def register():
    for cls in classes:
        bpy.utils.register_class(cls)
  


        

 
def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)

     
 
 
if __name__ == "__main__":
    register() 
    
    
     
