 
import bpy
import math
from bpy.props import (BoolProperty, FloatProperty, IntProperty)




#====================== Add Noise Modifier ====================

 
class OBJECT_OT_add_noise_fcurve_modifier_anbx(bpy.types.Operator):
    '''Add Noise Modifier to Selected Object(s) -
    
- applied to the corresponding Keyframe(s)
- according to the selected Option / Axis'''

    bl_idname = "object.add_noise_fcurve_modifier_anbx"
    bl_label = "Add F-Curve Noise"
    bl_options = {'REGISTER', 'UNDO'}

    @classmethod
    def poll(cls, context):
        return (context.object is not None and
                context.object.mode == 'OBJECT' and
                len(context.selected_objects) != 0 )
 


    def execute(self, context):

        # Ref
        x_axis = context.scene.noise_modifier_fcurve_x_axis_anbx
        y_axis = context.scene.noise_modifier_fcurve_y_axis_anbx
        z_axis = context.scene.noise_modifier_fcurve_z_axis_anbx

        noise_loc = context.scene.noise_modifier_fcurve_location_anbx
        noise_rot = context.scene.noise_modifier_fcurve_rotation_anbx
        noise_scale = context.scene.noise_modifier_fcurve_scale_anbx
        noise_light_power =  context.scene.noise_modifier_fcurve_light_power_anbx
        shape_key_value = context.scene.noise_modifier_fcurve_shape_key_value_anbx
        curve_bevel_depth = context.scene.noise_modifier_fcurve_bevel_depth_anbx
        


#--------------------------- Self Report -------------------------------------

            
        for o in bpy.context.selected_objects:



            # ----------------------- Shape Keys ------------------------- 

            shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']  
            if shape_key_value:
            

                if o.type in shape_key_objects:


                    if o.data.shape_keys is None:
                        self.report({'INFO'}, 'No Shape Keys found')                        
                
                    if o.data.shape_keys:
                        c_blocks = o.data.shape_keys.key_blocks
                      
                        for c in c_blocks:
                            if c != c_blocks[0]: 
                                if c_blocks.data.animation_data is None:
                                    self.report({'INFO'}, 'Insert Value Key')


                                if c_blocks.data.animation_data:
                                    if c_blocks.data.animation_data.action is None:                             
                                        self.report({'INFO'}, 'Insert Value Key')


       

#--------------------------- End Self Report -------------------------------------



        for o in bpy.context.selected_objects:
            if o.animation_data:
                if o.animation_data.action:
 
                    action = o.animation_data.action
                    
                    
                    for fc in action.fcurves:
         
         
                        #------------------ Location ----------------
                        if noise_loc:
                            
                            if x_axis:
                                if fc.data_path == "location" and fc.array_index == 0:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1


                            if y_axis:
                                if fc.data_path == "location" and fc.array_index == 1:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1


                            if z_axis:
                                if fc.data_path == "location" and fc.array_index == 2:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1

 
             
                            if not x_axis and not y_axis and not z_axis:
                                if fc.data_path == "location":
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1



                        #------------------ Rotation ----------------
                        if noise_rot:
                            
                            if x_axis:
                                if fc.data_path == "rotation_euler" and fc.array_index == 0:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1


                            if y_axis:
                                if fc.data_path == "rotation_euler" and fc.array_index == 1:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1


                            if z_axis:
                                if fc.data_path == "rotation_euler" and fc.array_index == 2:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1


             
                            if not x_axis and not y_axis and not z_axis:
                                if fc.data_path == "rotation_euler":
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1

                                     
                                                        
                        
                        #------------------ Scale ----------------
                        if noise_scale:
                            
                            if x_axis:
                                if fc.data_path == "scale" and fc.array_index == 0:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1


                            if y_axis:
                                if fc.data_path == "scale" and fc.array_index == 1:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1


                            if z_axis:
                                if fc.data_path == "scale" and fc.array_index == 2:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1

             
                            if not x_axis and not y_axis and not z_axis:
                                if fc.data_path == "scale":
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1

                                 
 
         
                        #------------------ Location Rotation----------------

                        if noise_loc and noise_rot:
                            
                            if x_axis:
                                if fc.data_path == "location" and fc.data_path == "rotation_euler"  and fc.array_index == 0:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1


                            if y_axis:
                                if fc.data_path == "location" and fc.data_path == "rotation_euler" and fc.array_index == 1:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1


                            if z_axis:
                                if fc.data_path == "location" and fc.data_path == "rotation_euler" and fc.array_index == 2:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1

 
                            if not x_axis and not y_axis and not z_axis:
                                if fc.data_path == "location" and fc.data_path == "rotation_euler":
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1

                     

 
         
                        #------------------ Location Scale----------------

                        if noise_loc and noise_scale:
                            
                            if x_axis:
                                if fc.data_path == "location" and fc.data_path == "scale"  and fc.array_index == 0:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1


                            if y_axis:
                                if fc.data_path == "location" and fc.data_path == "scale" and fc.array_index == 1:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1


                            if z_axis:
                                if fc.data_path == "location" and fc.data_path == "scale" and fc.array_index == 2:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1


                            if not x_axis and not y_axis and not z_axis:
                                if fc.data_path == "location" and fc.data_path == "scale":
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1

                                               
 

         
                        #------------------ Rotation Scale ----------------

                        if noise_rot and noise_scale:
                            
                            if x_axis:
                                if fc.data_path == "scale" and fc.data_path == "rotation_euler"  and fc.array_index == 0:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1


                            if y_axis:
                                if fc.data_path == "scale" and fc.data_path == "rotation_euler" and fc.array_index == 1:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1


                            if z_axis:
                                if fc.data_path == "scale" and fc.data_path == "rotation_euler" and fc.array_index == 2:
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1

             
                            if not x_axis and not y_axis and not z_axis:
                                if fc.data_path == "scale" and fc.data_path == "rotation_euler":
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1

                      
         
                        #------------------ All  Transform. ----------------                          
                        else:
                            if not noise_loc and not noise_rot and not noise_scale: 
                                if not x_axis and not y_axis and not z_axis:
                                    if fc.data_path == "location":
                                        noise_mod = fc.modifiers.new("NOISE")
                                        noise_mod.scale = 1    
                                        
                                    if fc.data_path == "rotation_euler":
                                        noise_mod = fc.modifiers.new("NOISE")
                                        noise_mod.scale = 1    
                                        
                                    if fc.data_path == "scale":
                                        noise_mod = fc.modifiers.new("NOISE")
                                        noise_mod.scale = 1    
                                        
                                               


                                                                                            
        #------------------ Light -----------------------------------------

 
        cur_frame = bpy.context.scene.frame_current  


        for o in bpy.context.selected_objects:
            if o.type == 'LIGHT' :

                # if bool is true
                if noise_light_power:

                    if o.data.animation_data:
                        if o.data.animation_data.action:
         
                            action = o.data.animation_data.action
                              
                            for fc in action.fcurves:
                                
                                if fc.data_path == "energy":
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1





                    if o.data.animation_data is None:
                        o.data.keyframe_insert(data_path = 'energy', frame= cur_frame)

                        action = o.data.animation_data.action
                        
                        for fc in action.fcurves:

                            # if bool is true
                            if noise_light_power:                    

                                if fc.data_path == "energy":
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1 



        #------------------ Curve Bevel Depth -----------------------------------------

                                     

        cur_frame = bpy.context.scene.frame_current

        for o in bpy.context.selected_objects:
            if o.type == 'CURVE':

                # if bool
                if curve_bevel_depth:

                    if o.data.animation_data:
                        if o.data.animation_data.action:
                            
                            action = o.data.animation_data.action
                            
                            for fc in action.fcurves:

                                if fc.data_path == "bevel_depth":
                                    noise_mod = fc.modifiers.new("NOISE")
                                    noise_mod.scale = 1 
            

                    if o.data.animation_data is None:
                        o.data.keyframe_insert(data_path = 'bevel_depth', frame= cur_frame)

                        action = o.data.animation_data.action
                        
                        for fc in action.fcurves:

                            if fc.data_path == "bevel_depth":
                                noise_mod = fc.modifiers.new("NOISE")
                                noise_mod.scale = 1 





        #----------------------- Shape Keys --------------------------------

        shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']
        
        for o in bpy.context.selected_objects:
            if o.type in shape_key_objects:   

                if o.data.shape_keys:
                    c_blocks = o.data.shape_keys.key_blocks
                  
                    for c in c_blocks:
                        if c != c_blocks[0]: 
                            if c_blocks.data.animation_data:
                                if c_blocks.data.animation_data.action:
                                    if c_blocks.data.animation_data.action.fcurves:
                                        action = c_blocks.data.animation_data.action
                                        
                                        for fc in action.fcurves:
                                            
                                            # if bool is true
                                            if shape_key_value:
                                                
                                                if fc.data_path.endswith("value"):
                                                    noise_mod = fc.modifiers.new("NOISE")
                                                    noise_mod.scale = 1
                                          
                     

                 
        return {'FINISHED'}

#====================== End "Add Noise Modifier" ====================






#====================== Remove Noise Modifier ====================

 
class OBJECT_OT_remove_noise_fcurve_modifier_anbx(bpy.types.Operator):
    '''Remove Noise Modifier
Reset Settings'''

    bl_idname = "object.remove_noise_fcurve_modifier_anbx"
    bl_label = "Remove F-Curve Noise"
    bl_options = {'REGISTER', 'UNDO'}

    @classmethod
    def poll(cls, context):
        return (context.object is not None and
                context.object.mode == 'OBJECT' and
                len(context.selected_objects) != 0 )
 

    def execute(self, context):


        bpy.context.scene.property_unset('noise_fcurve_mod_scale_anbx')
        bpy.context.scene.property_unset('noise_fcurve_mod_strength_anbx')
        bpy.context.scene.property_unset('noise_fcurve_mod_offset_anbx')
        bpy.context.scene.property_unset('noise_fcurve_mod_phase_anbx')
        bpy.context.scene.property_unset('noise_fcurve_mod_depth_anbx')
        bpy.context.scene.property_unset('noise_use_influence_anbx')
        bpy.context.scene.property_unset('noise_influence_anbx')
        bpy.context.scene.property_unset('noise_use_restricted_range_anbx')
        bpy.context.scene.property_unset('noise_restricted_frame_start_anbx')
        bpy.context.scene.property_unset('noise_restricted_frame_end_anbx')
        bpy.context.scene.property_unset('noise_restricted_blend_in_anbx')
        bpy.context.scene.property_unset('noise_restricted_blend_out_anbx')
        

        for o in bpy.context.selected_objects:
            if o.animation_data:
                if o.animation_data.action:
                    
                    action = o.animation_data.action
                    
                    for fc in action.fcurves:
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                fc.modifiers.remove(mod)  

                                      
                            fc.modifiers.update()

        
        
        for o in bpy.context.selected_objects:
            if o.data.animation_data:
                if o.data.animation_data.action:
                    
                    action = o.data.animation_data.action
                    
                    for fc in action.fcurves:
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                fc.modifiers.remove(mod)  

                                      
                            fc.modifiers.update()


        # ----------------- Shape Key Value -------------------
        
        shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']
        
        for o in bpy.context.selected_objects:
            if o.type in shape_key_objects:
  
                if o.data.shape_keys:
                    c_blocks = o.data.shape_keys.key_blocks
                  
                    for c in c_blocks:
                        if c != c_blocks[0]: 
                            if c_blocks.data.animation_data:
                                if c_blocks.data.animation_data.action:
                                    if c_blocks.data.animation_data.action.fcurves:
                                        action = c_blocks.data.animation_data.action
                                        
                                        for fc in action.fcurves:
                                            for mod in fc.modifiers:
                                                if mod.type == 'NOISE':
                                                    fc.modifiers.remove(mod)
                                                fc.modifiers.update()





        return {'FINISHED'}

#====================== End "Remove Noise Modifier" ====================




#====================== Reset Setting Noise Modifier ====================

 
class OBJECT_OT_reset_settings_noise_fcurve_modifier_anbx(bpy.types.Operator):
    '''Reset Settings - Noise Modifier'''

    bl_idname = "object.reset_settings_noise_fcurve_modifier_anbx"
    bl_label = "Reset Settings"
    bl_options = {'REGISTER', 'UNDO'}

    @classmethod
    def poll(cls, context):
        return (context.object is not None and
                context.object.mode == 'OBJECT' and
                len(context.selected_objects) != 0 )
 

    def execute(self, context):


        bpy.context.scene.property_unset('noise_fcurve_mod_scale_anbx')
        bpy.context.scene.property_unset('noise_fcurve_mod_strength_anbx')
        bpy.context.scene.property_unset('noise_fcurve_mod_offset_anbx')
        bpy.context.scene.property_unset('noise_fcurve_mod_phase_anbx')
        bpy.context.scene.property_unset('noise_fcurve_mod_depth_anbx')
        bpy.context.scene.property_unset('noise_use_influence_anbx')
        bpy.context.scene.property_unset('noise_influence_anbx')
        bpy.context.scene.property_unset('noise_use_restricted_range_anbx')
        bpy.context.scene.property_unset('noise_restricted_frame_start_anbx')
        bpy.context.scene.property_unset('noise_restricted_frame_end_anbx')
        bpy.context.scene.property_unset('noise_restricted_blend_in_anbx')
        bpy.context.scene.property_unset('noise_restricted_blend_out_anbx')
        


        for o in bpy.context.selected_objects:
            if o.animation_data:
                if o.animation_data.action:
                    
                    action = o.animation_data.action
                    
                    for fc in action.fcurves:
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.scale = 1.000
                                mod.strength = 1.000
                                mod.offset = 0.000
                                mod.phase = 1.000
                                mod.depth = 0
                                mod.use_influence = False
                                mod.influence = 1.000
                                mod.use_restricted_range = False                           
                                mod.frame_start = 0.000                                               
                                mod.frame_end = 0.000                                                       
                                mod.blend_in = 0.000                             
                                mod.blend_out = 0.000            
         
         
                            fc.modifiers.update()
     
        
        for o in bpy.context.selected_objects:
            if o.data.animation_data:
                if o.data.animation_data.action:
                    
                    action = o.data.animation_data.action
                    
                    for fc in action.fcurves:
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.scale = 1.000
                                mod.strength = 1.000
                                mod.offset = 0.000
                                mod.phase = 1.000
                                mod.depth = 0 
                                mod.use_influence = False
                                mod.influence = 1.000
                                mod.use_restricted_range = False                           
                                mod.frame_start = 0.000                                               
                                mod.frame_end = 0.000                                                       
                                mod.blend_in = 0.000                             
                                mod.blend_out = 0.000                            
 
                                      
                            fc.modifiers.update()


        # ----------------- Shape Key Value -------------------
        

        shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']
        
        for o in bpy.context.selected_objects:
            if o.type in shape_key_objects:

 
                if o.data.shape_keys:
                    c_blocks = o.data.shape_keys.key_blocks
                  
                    for c in c_blocks:
                        if c != c_blocks[0]: 
                            if c_blocks.data.animation_data:
                                if c_blocks.data.animation_data.action:
                                    if c_blocks.data.animation_data.action.fcurves:
                                        action = c_blocks.data.animation_data.action
                                        
                                        for fc in action.fcurves:
                                            for mod in fc.modifiers:
                                                if mod.type == 'NOISE':
                                                    mod.scale = 1.000
                                                    mod.strength = 1.000
                                                    mod.offset = 0.000
                                                    mod.phase = 1.000
                                                    mod.depth = 0 
                                                    mod.use_influence = False
                                                    mod.influence = 1.000
                                                    mod.use_restricted_range = False                           
                                                    mod.frame_start = 0.000                                               
                                                    mod.frame_end = 0.000                                                       
                                                    mod.blend_in = 0.000                             
                                                    mod.blend_out = 0.000      
                     
                                                fc.modifiers.update()

         

        return {'FINISHED'}

#====================== End "Reset Setting Noise Modifier" ====================







#======================  Update Func. ====================


def noise_mod_scale(self, context):


    offset = 0
    offset_per_obj = context.scene.noise_modifier_fcurve_offset_per_obj_anbx
    reversed_offset = context.scene.noise_modifier_fcurve_offset_reversed_anbx

    sel_ob = bpy.context.selected_objects

    if reversed_offset:
        sel_ob = reversed(sel_ob) 

    for o in sel_ob:
        if o.animation_data is not None:    
            action = o.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:
                    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.scale = self.noise_fcurve_mod_scale_anbx + offset

                            if offset_per_obj:
                                offset += self.noise_fcurve_mod_scale_anbx                                  
                                            
                            fc.modifiers.update()      
          

    sel_ob = bpy.context.selected_objects

    if reversed_offset:
        sel_ob = reversed(sel_ob)           

    for o in sel_ob:
        if o.data.animation_data is not None:    
            action = o.data.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:
                    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.scale = self.noise_fcurve_mod_scale_anbx + offset

                            if offset_per_obj:
                                offset += self.noise_fcurve_mod_scale_anbx                                 
                                            
                            fc.modifiers.update()      
           
 

    shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']
        
              
    sel_ob = bpy.context.selected_objects

    if reversed_offset:
        sel_ob = reversed(sel_ob) 

    for o in sel_ob:
        if o.type in shape_key_objects:

            if o.data.shape_keys:
                c_blocks = o.data.shape_keys.key_blocks
              
                for c in c_blocks:
                    if c != c_blocks[0]: 
                        if c_blocks.data.animation_data:
                            if c_blocks.data.animation_data.action.fcurves:
                                action = c_blocks.data.animation_data.action
                                if action is not None:
                                    if action.fcurves:
                                        for fc in action.fcurves:
                                    
                                            for mod in fc.modifiers:
                                                if mod.type == 'NOISE':
                                                    mod.scale = self.noise_fcurve_mod_scale_anbx + offset

                                                if offset_per_obj:
                                                    offset += self.noise_fcurve_mod_scale_anbx       

                                                                
                                                fc.modifiers.update()   
                     
                 
 

     
def noise_mod_strength(self, context):


    offset = 0
    offset_per_obj = context.scene.noise_modifier_fcurve_offset_per_obj_anbx
    reversed_offset = context.scene.noise_modifier_fcurve_offset_reversed_anbx

    sel_ob = bpy.context.selected_objects

    if reversed_offset:
        sel_ob = reversed(sel_ob) 

    for o in sel_ob:
        if o.animation_data is not None:    
            action = o.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:
                    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.strength = self.noise_fcurve_mod_strength_anbx + offset

                            if offset_per_obj:
                                offset += self.noise_fcurve_mod_strength_anbx                                   
                                            
                            fc.modifiers.update()      


    sel_ob = bpy.context.selected_objects

    if reversed_offset:
        sel_ob = reversed(sel_ob)           

    for o in sel_ob:
        if o.data.animation_data is not None:    
            action = o.data.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:
                    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.strength = self.noise_fcurve_mod_strength_anbx + offset

                            if offset_per_obj:
                                offset += self.noise_fcurve_mod_strength_anbx                                  
                                            
                            fc.modifiers.update()     


    shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']                        
           
    sel_ob = bpy.context.selected_objects

    if reversed_offset:
        sel_ob = reversed(sel_ob) 
 
    for o in sel_ob:
        if o.type in shape_key_objects:

            if o.data.shape_keys:
                c_blocks = o.data.shape_keys.key_blocks
              
                for c in c_blocks:
                    if c != c_blocks[0]: 
                        if c_blocks.data.animation_data:
                            if c_blocks.data.animation_data.action.fcurves:
                                action = c_blocks.data.animation_data.action
                                if action is not None:
                                    if action.fcurves:
                                        for fc in action.fcurves:
                                    
                                            for mod in fc.modifiers:
                                                if mod.type == 'NOISE':
                                                    mod.strength = self.noise_fcurve_mod_strength_anbx + offset

                                                if offset_per_obj:
                                                    offset += self.noise_fcurve_mod_strength_anbx                                                  
                                                                
                                                fc.modifiers.update() 


     

def noise_mod_offset(self, context):


    offset = 0
    offset_per_obj = context.scene.noise_modifier_fcurve_offset_per_obj_anbx
    reversed_offset = context.scene.noise_modifier_fcurve_offset_reversed_anbx

    sel_ob = bpy.context.selected_objects

    if reversed_offset:
        sel_ob = reversed(sel_ob) 

    for o in sel_ob:
        if o.animation_data is not None:    
            action = o.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:
                    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.offset = self.noise_fcurve_mod_offset_anbx + offset

                            if offset_per_obj:
                                offset += self.noise_fcurve_mod_offset_anbx                                    
                                            
                            fc.modifiers.update()      
          

    sel_ob = bpy.context.selected_objects

    if reversed_offset:
        sel_ob = reversed(sel_ob) 

    for o in sel_ob:
        if o.data.animation_data is not None:    
            action = o.data.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:
              
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.offset = self.noise_fcurve_mod_offset_anbx + offset

                            if offset_per_obj:
                                offset += self.noise_fcurve_mod_offset_anbx                                 
                                            
                            fc.modifiers.update()      
          

    shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']     

    sel_ob = bpy.context.selected_objects

    if reversed_offset:
        sel_ob = reversed(sel_ob) 
 
    for o in sel_ob:
        if o.type in shape_key_objects:

            if o.data.shape_keys:
                c_blocks = o.data.shape_keys.key_blocks
              
                for c in c_blocks:
                    if c != c_blocks[0]: 
                        if c_blocks.data.animation_data:
                            if c_blocks.data.animation_data.action.fcurves:
                                action = c_blocks.data.animation_data.action
                                if action is not None:
                                    if action.fcurves:
                                        for fc in action.fcurves:

                                            for mod in fc.modifiers:
                                                if mod.type == 'NOISE':
                                                    mod.offset = self.noise_fcurve_mod_offset_anbx + offset

                                                if offset_per_obj:
                                                    offset += self.noise_fcurve_mod_offset_anbx  

                                                                
                                                fc.modifiers.update()      
                              
                                                        

    
def noise_mod_phase(self, context):


    offset = 0
    offset_per_obj = context.scene.noise_modifier_fcurve_offset_per_obj_anbx
    reversed_offset = context.scene.noise_modifier_fcurve_offset_reversed_anbx

    sel_ob = bpy.context.selected_objects

    if reversed_offset:
        sel_ob = reversed(sel_ob) 

    for o in sel_ob:
        if o.animation_data is not None:    
            action = o.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:
                    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.phase = self.noise_fcurve_mod_phase_anbx + offset
                                        
                            if offset_per_obj:
                                offset += self.noise_fcurve_mod_phase_anbx   

                            fc.modifiers.update()   


    sel_ob = bpy.context.selected_objects

    if reversed_offset:
        sel_ob = reversed(sel_ob) 

    for o in sel_ob:
        if o.data.animation_data is not None:    
            action = o.data.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:

                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.phase = self.noise_fcurve_mod_phase_anbx + offset

                            if offset_per_obj:
                                offset += self.noise_fcurve_mod_phase_anbx                                
                                            
                            fc.modifiers.update()  


    shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']                        

    sel_ob = bpy.context.selected_objects

    if reversed_offset:
        sel_ob = reversed(sel_ob) 
 
    for o in sel_ob:
        if o.type in shape_key_objects:

            if o.data.shape_keys:
                c_blocks = o.data.shape_keys.key_blocks
              
                for c in c_blocks:
                    if c != c_blocks[0]: 
                        if c_blocks.data.animation_data:
                            if c_blocks.data.animation_data.action.fcurves:
                                action = c_blocks.data.animation_data.action
                                if action is not None:
                                    if action.fcurves:
                                        for fc in action.fcurves:
                                    
                                            for mod in fc.modifiers:
                                                if mod.type == 'NOISE':
                                                    mod.phase = self.noise_fcurve_mod_phase_anbx + offset

                                                if offset_per_obj:
                                                    offset += self.noise_fcurve_mod_phase_anbx
                                                                
                                                fc.modifiers.update()     

     


def noise_mod_depth(self, context):

    for o in bpy.context.selected_objects:
        if o.animation_data is not None:    
            action = o.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:
                    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.depth = self.noise_fcurve_mod_depth_anbx
                                            
                            fc.modifiers.update()      
          
  
    for o in bpy.context.selected_objects:
        if o.data.animation_data is not None:    
            action = o.data.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:  
                        
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.depth = self.noise_fcurve_mod_depth_anbx
                                            
                            fc.modifiers.update()      
            

    shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']  

    for o in bpy.context.selected_objects:
        if o.type in shape_key_objects:

            if o.data.shape_keys:
                c_blocks = o.data.shape_keys.key_blocks
              
                for c in c_blocks:
                    if c != c_blocks[0]: 
                        if c_blocks.data.animation_data:
                            if c_blocks.data.animation_data.action.fcurves:
                                action = c_blocks.data.animation_data.action
                                if action is not None:
                                    if action.fcurves:
                                        for fc in action.fcurves:
     
                                            for mod in fc.modifiers:
                                                if mod.type == 'NOISE':
                                                    mod.depth = self.noise_fcurve_mod_depth_anbx
                                                                
                                                fc.modifiers.update()      
                                
                                

               
     
def noise_mod_use_influence(self, context):

    for o in bpy.context.selected_objects:
        if o.animation_data is not None:    
            action = o.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:
                    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.use_influence = self.noise_use_influence_anbx
                                            
                            fc.modifiers.update()   
                               
          
    for o in bpy.context.selected_objects:
        if o.data.animation_data is not None:    
            action = o.data.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:            
          
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.use_influence = self.noise_use_influence_anbx
                                            
                            fc.modifiers.update()           


 
    shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']  

    for o in bpy.context.selected_objects:
        if o.type in shape_key_objects:

            if o.data.shape_keys:
                c_blocks = o.data.shape_keys.key_blocks
              
                for c in c_blocks:
                    if c != c_blocks[0]: 
                        if c_blocks.data.animation_data:
                            if c_blocks.data.animation_data.action.fcurves:
                                action = c_blocks.data.animation_data.action
                                if action is not None:
                                    if action.fcurves:
                                        for fc in action.fcurves:
                                    
                                            for mod in fc.modifiers:
                                                if mod.type == 'NOISE':
                                                    mod.use_influence = self.noise_use_influence_anbx
                                                                
                                                fc.modifiers.update()           

                                                    
                    
def noise_mod_influence(self, context):

    for o in bpy.context.selected_objects:
        if o.animation_data is not None:    
            action = o.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:
                    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.influence = self.noise_influence_anbx
                                            
                            fc.modifiers.update()      
          
          
    for o in bpy.context.selected_objects:
        if o.data.animation_data is not None:    
            action = o.data.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:                          
  
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.influence = self.noise_influence_anbx
                                            
                            fc.modifiers.update()    
 
 
    shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']  

    for o in bpy.context.selected_objects:
        if o.type in shape_key_objects:

            if o.data.shape_keys:
                c_blocks = o.data.shape_keys.key_blocks
              
                for c in c_blocks:
                    if c != c_blocks[0]: 
                        if c_blocks.data.animation_data:
                            if c_blocks.data.animation_data.action.fcurves:
                                action = c_blocks.data.animation_data.action
                                if action is not None:
                                    if action.fcurves:
                                        for fc in action.fcurves:
                                     
                                            for mod in fc.modifiers:
                                                if mod.type == 'NOISE':
                                                    mod.influence = self.noise_influence_anbx
                                                                
                                                fc.modifiers.update() 
         
 
 
def noise_mod_restrict_frame_range(self, context):

    for o in bpy.context.selected_objects:
        if o.animation_data is not None:    
            action = o.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:
                    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.use_restricted_range = self.noise_use_restricted_range_anbx
                                            
                            fc.modifiers.update()      


    for o in bpy.context.selected_objects:
        if o.data.animation_data is not None:    
            action = o.data.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:           

                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.use_restricted_range = self.noise_use_restricted_range_anbx
                                            
                            fc.modifiers.update()  



    shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']  

    for o in bpy.context.selected_objects:
        if o.type in shape_key_objects:

            if o.data.shape_keys:
                c_blocks = o.data.shape_keys.key_blocks
              
                for c in c_blocks:
                    if c != c_blocks[0]: 
                        if c_blocks.data.animation_data:
                            if c_blocks.data.animation_data.action.fcurves:
                                action = c_blocks.data.animation_data.action
                                if action is not None:
                                    if action.fcurves:
                                        for fc in action.fcurves:
                                    
                                            for mod in fc.modifiers:
                                                if mod.type == 'NOISE':
                                                    mod.use_restricted_range = self.noise_use_restricted_range_anbx
                                                                
                                                fc.modifiers.update()  




                         
      
def noise_mod_restrict_frame_start(self, context):

    for o in bpy.context.selected_objects:
        if o.animation_data is not None:    
            action = o.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:
                    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.frame_start = self.noise_restricted_frame_start_anbx
                                            
                            fc.modifiers.update()      
          


    for o in bpy.context.selected_objects:
        if o.data.animation_data is not None:    
            action = o.data.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:  
                    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.frame_start = self.noise_restricted_frame_start_anbx
                                            
                            fc.modifiers.update()      
          
 
    shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']  

    for o in bpy.context.selected_objects:
        if o.type in shape_key_objects:

            if o.data.shape_keys:
                c_blocks = o.data.shape_keys.key_blocks
              
                for c in c_blocks:
                    if c != c_blocks[0]: 
                        if c_blocks.data.animation_data:
                            if c_blocks.data.animation_data.action.fcurves:
                                action = c_blocks.data.animation_data.action
                                if action is not None:
                                    if action.fcurves:
                                        for fc in action.fcurves:
                                    
                                            for mod in fc.modifiers:
                                                if mod.type == 'NOISE':
                                                    mod.frame_start = self.noise_restricted_frame_start_anbx
                                                                
                                                fc.modifiers.update()      
                              
                                                     
       
      
def noise_mod_restrict_frame_end(self, context):

    for o in bpy.context.selected_objects:
        if o.animation_data is not None:    
            action = o.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:
                    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.frame_end = self.noise_restricted_frame_end_anbx
                                            
                            fc.modifiers.update()      
          

    for o in bpy.context.selected_objects:
        if o.data.animation_data is not None:    
            action = o.data.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:                           
    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.frame_end = self.noise_restricted_frame_end_anbx
                                            
                            fc.modifiers.update()     
                            


    shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']  

    for o in bpy.context.selected_objects:
        if o.type in shape_key_objects:

            if o.data.shape_keys:
                c_blocks = o.data.shape_keys.key_blocks
              
                for c in c_blocks:
                    if c != c_blocks[0]: 
                        if c_blocks.data.animation_data:
                            if c_blocks.data.animation_data.action.fcurves:
                                action = c_blocks.data.animation_data.action
                                if action is not None:
                                    if action.fcurves:
                                        for fc in action.fcurves:
                                    
                                            for mod in fc.modifiers:
                                                if mod.type == 'NOISE':
                                                    mod.frame_end = self.noise_restricted_frame_end_anbx
                                                                
                                                fc.modifiers.update()     
                                                        
                                                 
 
def noise_mod_restrict_blend_in(self, context):

    for o in bpy.context.selected_objects:
        if o.animation_data is not None:    
            action = o.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:
                    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.blend_in = self.noise_restricted_blend_in_anbx
                                            
                            fc.modifiers.update()      
          
          

    for o in bpy.context.selected_objects:
        if o.data.animation_data is not None:    
            action = o.data.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:  
                                  
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.blend_in = self.noise_restricted_blend_in_anbx
                                            
                            fc.modifiers.update()    
                              

 
    shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']  

    for o in bpy.context.selected_objects:
        if o.type in shape_key_objects:

            if o.data.shape_keys:
                c_blocks = o.data.shape_keys.key_blocks
              
                for c in c_blocks:
                    if c != c_blocks[0]: 
                        if c_blocks.data.animation_data:
                            if c_blocks.data.animation_data.action.fcurves:
                                action = c_blocks.data.animation_data.action
                                if action is not None:
                                    if action.fcurves:
                                        for fc in action.fcurves:
                                    
                                            for mod in fc.modifiers:
                                                if mod.type == 'NOISE':
                                                    mod.blend_in = self.noise_restricted_blend_in_anbx
                                                                
                                                fc.modifiers.update()    
                                             
                    

def noise_mod_restrict_blend_out(self, context):

    for o in bpy.context.selected_objects:
        if o.animation_data is not None:    
            action = o.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:
                    
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.blend_out = self.noise_restricted_blend_out_anbx
                                            
                            fc.modifiers.update()      
          
                         

    for o in bpy.context.selected_objects:
        if o.data.animation_data is not None:    
            action = o.data.animation_data.action  
            if action is not None:
                if action.fcurves:
                    for fc in action.fcurves:  
                         
                        for mod in fc.modifiers:
                            if mod.type == 'NOISE':
                                mod.blend_out = self.noise_restricted_blend_out_anbx
                                            
                            fc.modifiers.update()      
           
 
 
    shape_key_objects = ['MESH', 'CURVE', 'SURFACE', 'LATTICE']  

    for o in bpy.context.selected_objects:
        if o.type in shape_key_objects:

            if o.data.shape_keys:
                c_blocks = o.data.shape_keys.key_blocks
              
                for c in c_blocks:
                    if c != c_blocks[0]: 
                        if c_blocks.data.animation_data:
                            if c_blocks.data.animation_data.action.fcurves:
                                action = c_blocks.data.animation_data.action
                                if action is not None:
                                    if action.fcurves:
                                        for fc in action.fcurves:
                                     
                                            for mod in fc.modifiers:
                                                if mod.type == 'NOISE':
                                                    mod.blend_out = self.noise_restricted_blend_out_anbx
                                                                
                                                fc.modifiers.update()      
                           
                           
     
#====================== End "Update Func." ==================== 
        
 

        

classes = [ OBJECT_OT_add_noise_fcurve_modifier_anbx,
            OBJECT_OT_remove_noise_fcurve_modifier_anbx,
            OBJECT_OT_reset_settings_noise_fcurve_modifier_anbx,
             
 
            
          ]
 
 
 
def register():
    for cls in classes:
        bpy.utils.register_class(cls)


#=============================== Offset Per Object =======

    # Offset Setting per Object
    bpy.types.Scene.noise_modifier_fcurve_offset_per_obj_anbx = bpy.props.BoolProperty(
        name="",
        description="Noise Modifier Setting Offset - Per Object (Checkbox)",
        default = False
    )


    # Reversed Selected Objects
    bpy.types.Scene.noise_modifier_fcurve_offset_reversed_anbx = bpy.props.BoolProperty(
        name="",
        description="Reversed Offset (Checkbox)",
        default = False
    )



#========================= Axis ==========================

    bpy.types.Scene.noise_modifier_fcurve_x_axis_anbx = bpy.props.BoolProperty(
        name="",
        description="Noise Scale Modifier X Axis (Checkbox)",
        default = False
    )

    bpy.types.Scene.noise_modifier_fcurve_y_axis_anbx = bpy.props.BoolProperty(
        name="",
        description="Noise Scale Modifier Y Axis (Checkbox)",
        default = False
    )

    bpy.types.Scene.noise_modifier_fcurve_z_axis_anbx = bpy.props.BoolProperty(
        name="",
        description="Noise Scale Modifier Z Axis (Checkbox)",
        default = False
    )


#========================= Axis ==========================


#========================= Loc Rot Scale ==========================


    bpy.types.Scene.noise_modifier_fcurve_location_anbx = bpy.props.BoolProperty(
        name="",
        description="Noise Modifier - Location (Checkbox)",
        default = False
    )

    bpy.types.Scene.noise_modifier_fcurve_rotation_anbx = bpy.props.BoolProperty(
        name="",
        description="Noise Modifier - Rotation (Checkbox)",
        default = False
    )

    bpy.types.Scene.noise_modifier_fcurve_scale_anbx = bpy.props.BoolProperty(
        name="",
        description="Noise Modifier - Scale (Checkbox)",
        default = False
    )


#========================= End "Loc Rot Scale" ==========================



#=========================== Light ======================================

    bpy.types.Scene.noise_modifier_fcurve_light_power_anbx = bpy.props.BoolProperty(
        name="",
        description="Noise Modifier - Light Power (Checkbox)",
        default = False
    )



#=========================== Shape Keys ======================================

    bpy.types.Scene.noise_modifier_fcurve_shape_key_value_anbx = bpy.props.BoolProperty(
        name="",
        description="Noise Modifier - Shape Key Value (Checkbox)",
        default = False
    )


#=========================== Curve Bevel Depth ======================================

    bpy.types.Scene.noise_modifier_fcurve_bevel_depth_anbx = bpy.props.BoolProperty(
        name="",
        description="Noise Modifier - Curve Bevel Depth (Checkbox)",
        default = False
    )






#========================= Param ==========================


      
    # Scale 
    bpy.types.Scene.noise_fcurve_mod_scale_anbx = bpy.props.FloatProperty(
        name="", 
        default=1.0,
        description="Scaling (in time) of the noise - Selected Object(s)",
        precision=3,         
        update = noise_mod_scale,
    )
     

    # Strength
    bpy.types.Scene.noise_fcurve_mod_strength_anbx = bpy.props.FloatProperty(
        name="", 
        default=1.0,
        description="Amplitude of the noise - Selected Object(s)",
        precision=3,         
        update = noise_mod_strength,
    )
     
 
    # Offset
    bpy.types.Scene.noise_fcurve_mod_offset_anbx = bpy.props.FloatProperty(
        name="", 
        default=0.0,
        description="Time offset for the noise effect - Selected Object(s)",
        precision=3,         
        update = noise_mod_offset,
    )
     


    # Phase
    bpy.types.Scene.noise_fcurve_mod_phase_anbx = bpy.props.FloatProperty(
        name="", 
        default=1.0,
        description="A random seed for the noise effect - Selected Object(s)",
        precision=3,         
        update = noise_mod_phase,
    )
     
 
    bpy.types.Scene.noise_fcurve_mod_depth_anbx = bpy.props.IntProperty(
        name="",
        default=0,
        description="Amount of fine level detail present in the noise - Selected Object(s)",
        min=0,
        update = noise_mod_depth,
    )
 
 
    # use influence check box   
    bpy.types.Scene.noise_use_influence_anbx = bpy.props.BoolProperty(
        name="",
        description="Use Influence",
        update= noise_mod_use_influence,
        default = False,
    )


    # Influence
    bpy.types.Scene.noise_influence_anbx = bpy.props.FloatProperty(
        name="", 
        default=1.0,
        min=0.000, max=1.0,
        description="Amount of Influence - Selected Object(s)",
        precision=3,         
        update = noise_mod_influence,
    )
     

    # use Restrict Frame Range check box   
    bpy.types.Scene.noise_use_restricted_range_anbx = bpy.props.BoolProperty(
        name="",
        description="Restrict Frame Range",
        update= noise_mod_restrict_frame_range,
        default = False,
    )


    # Restricted Start Frame
    bpy.types.Scene.noise_restricted_frame_start_anbx = bpy.props.FloatProperty(
        name="", 
        default=0.0,
        description="Start Frame",
        precision=3,         
        update = noise_mod_restrict_frame_start,
    )
     

    # Restricted End Frame
    bpy.types.Scene.noise_restricted_frame_end_anbx = bpy.props.FloatProperty(
        name="", 
        default=0.0,
        description="End Frame",
        precision=3,         
        update = noise_mod_restrict_frame_end,
    )
     

    # Restricted Blend In
    bpy.types.Scene.noise_restricted_blend_in_anbx = bpy.props.FloatProperty(
        name="", 
        default=0.0,
        min=0.0,
        description="Blend In",
        precision=3,         
        update = noise_mod_restrict_blend_in,
    )
     

    # Restricted Blend Out
    bpy.types.Scene.noise_restricted_blend_out_anbx = bpy.props.FloatProperty(
        name="", 
        default=0.0,
        min=0.0,
        description="Blend Out",
        precision=3,         
        update = noise_mod_restrict_blend_out,
    )
     





 
def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)

    del bpy.types.Scene.noise_fcurve_mod_scale_anbx
    del bpy.types.Scene.noise_fcurve_mod_strength_anbx
    del bpy.types.Scene.noise_fcurve_mod_offset_anbx
    del bpy.types.Scene.noise_fcurve_mod_phase_anbx
    del bpy.types.Scene.noise_fcurve_mod_depth_anbx
    
    del bpy.types.Scene.noise_modifier_fcurve_offset_per_obj_anbx
    del bpy.types.Scene.noise_modifier_fcurve_offset_reversed_anbx

    del bpy.types.Scene.noise_modifier_fcurve_x_axis_anbx
    del bpy.types.Scene.noise_modifier_fcurve_y_axis_anbx
    del bpy.types.Scene.noise_modifier_fcurve_z_axis_anbx
 
    del bpy.types.Scene.noise_modifier_fcurve_location_anbx 
    del bpy.types.Scene.noise_modifier_fcurve_rotation_anbx 
    del bpy.types.Scene.noise_modifier_fcurve_scale_anbx 
    del bpy.types.Scene.noise_modifier_fcurve_light_power_anbx
    del bpy.types.Scene.noise_modifier_fcurve_shape_key_value_anbx
    del bpy.types.Scene.noise_modifier_fcurve_bevel_depth_anbx
    
    del bpy.types.Scene.noise_use_influence_anbx
    del bpy.types.Scene.noise_influence_anbx
    del bpy.types.Scene.noise_use_restricted_range_anbx
    del bpy.types.Scene.noise_restricted_frame_start_anbx
    del bpy.types.Scene.noise_restricted_frame_end_anbx
    del bpy.types.Scene.noise_restricted_blend_in_anbx
    del bpy.types.Scene.noise_restricted_blend_out_anbx
 
 
if __name__ == "__main__":
    register() 
    
    
     
